#include "spnLight.hpp"
#define PL_SIG_SREC_LP 0
#define PL_Led_LP 1
#define PL_Controller_LP 2
#define PL_SerialPort_LP 3
#define TR_EMPTY_SREC_RT 0
#define TR_INCOMING_SREC_RT 1
#define TR_I1079_S_MORE_S_FOFF_L_Onp_L_Receive_RT 2
#define TR_I1078_S_MORE_S_FOFF_L_Flash_Off_L_Onp_L_Receive_RT 3
#define TR_I1077_S_MORE_S_FOFF_L_Flash_On_L_Onp_L_Receive_RT 4
#define TR_I1075_S_LESS_L_Receive_RT 5
#define TR_I1073_S_LESS_L_Receive_RT 6
#define TR_I1072_S_LESS_L_Onp_L_Receive_RT 7
#define TR_RSREC1029__RT 8
#define TR_I1082_L_NoData_RT 9
#define TR_I1070_S_FON_L_Off_RT 10
#define TR_I1069_S_FON_L_Off_RT 11
#define TR_I1066_S_FON_L_Off_L_Off_RT 12
#define TR_D891_Off_RT 13
#define TR_D1039_L_Onp_RT 14
#define TR_D991_L_On_RT 15
#define TR_D899_L_Flash_Off_RT 16
#define TR_D984_L_Flash_On_RT 17

const int _nb_Place_SIG_SREC=0;
const int _nb_Place_Led=1;
const int _nb_Place_Controller=2;
const int _nb_Place_SerialPort=3;
namespace hybridVar {
}
#include "magic.hpp"
#include "markingImpl.hpp"

void abstractMarking::resetToInitMarking(){
	magicReset();
	P->_PL_SIG_SREC =0;
	P->_PL_Led =898;
	P->_PL_Controller =886;
	P->_PL_SerialPort =1025;
}


abstractMarking::abstractMarking() {
	P= new abstractMarkingImpl;
	resetToInitMarking();
}

abstractMarking::~abstractMarking() {
	delete(P);
}


static const TR_PL_ID EMPTY_array[1]={-1};
static const TR_PL_ID PE_PossiblyEnabled_0[2]= {TR_INCOMING_SREC_RT, -1 }; /* EMPTY_SREC*/
static const TR_PL_ID PE_PossiblyEnabled_1[3]= {TR_EMPTY_SREC_RT, TR_RSREC1029__RT, -1 }; /* INCOMING_SREC*/
static const TR_PL_ID PE_PossiblyEnabled_2[3]= {TR_RSREC1029__RT, TR_D891_Off_RT, -1 }; /* I1079_S_MORE_S_FOFF_L_Onp_L_Receive*/
static const TR_PL_ID PE_PossiblyEnabled_3[3]= {TR_RSREC1029__RT, TR_D891_Off_RT, -1 }; /* I1078_S_MORE_S_FOFF_L_Flash_Off_L_Onp_L_Receive*/
static const TR_PL_ID PE_PossiblyEnabled_4[3]= {TR_RSREC1029__RT, TR_D891_Off_RT, -1 }; /* I1077_S_MORE_S_FOFF_L_Flash_On_L_Onp_L_Receive*/
static const TR_PL_ID PE_PossiblyEnabled_5[3]= {TR_RSREC1029__RT, TR_D891_Off_RT, -1 }; /* I1075_S_LESS_L_Receive*/
static const TR_PL_ID PE_PossiblyEnabled_6[3]= {TR_RSREC1029__RT, TR_D991_L_On_RT, -1 }; /* I1073_S_LESS_L_Receive*/
static const TR_PL_ID PE_PossiblyEnabled_7[3]= {TR_RSREC1029__RT, TR_D991_L_On_RT, -1 }; /* I1072_S_LESS_L_Onp_L_Receive*/
static const TR_PL_ID PE_PossiblyEnabled_8[4]= {TR_EMPTY_SREC_RT, TR_INCOMING_SREC_RT, TR_I1082_L_NoData_RT, -1 }; /* RSREC1029_*/
static const TR_PL_ID PE_PossiblyEnabled_9[7]= {TR_I1079_S_MORE_S_FOFF_L_Onp_L_Receive_RT, TR_I1078_S_MORE_S_FOFF_L_Flash_Off_L_Onp_L_Receive_RT, TR_I1077_S_MORE_S_FOFF_L_Flash_On_L_Onp_L_Receive_RT, TR_I1075_S_LESS_L_Receive_RT, TR_I1073_S_LESS_L_Receive_RT, TR_I1072_S_LESS_L_Onp_L_Receive_RT, -1 }; /* I1082_L_NoData*/
static const TR_PL_ID PE_PossiblyEnabled_10[4]= {TR_I1073_S_LESS_L_Receive_RT, TR_D991_L_On_RT, TR_D899_L_Flash_Off_RT, -1 }; /* I1070_S_FON_L_Off*/
static const TR_PL_ID PE_PossiblyEnabled_11[4]= {TR_I1073_S_LESS_L_Receive_RT, TR_D991_L_On_RT, TR_D984_L_Flash_On_RT, -1 }; /* I1069_S_FON_L_Off*/
static const TR_PL_ID PE_PossiblyEnabled_12[4]= {TR_I1073_S_LESS_L_Receive_RT, TR_D991_L_On_RT, TR_D899_L_Flash_Off_RT, -1 }; /* I1066_S_FON_L_Off_L_Off*/
static const TR_PL_ID PE_PossiblyEnabled_13[4]= {TR_I1070_S_FON_L_Off_RT, TR_I1069_S_FON_L_Off_RT, TR_I1066_S_FON_L_Off_L_Off_RT, -1 }; /* D891_Off*/
static const TR_PL_ID PE_PossiblyEnabled_14[5]= {TR_I1079_S_MORE_S_FOFF_L_Onp_L_Receive_RT, TR_I1078_S_MORE_S_FOFF_L_Flash_Off_L_Onp_L_Receive_RT, TR_I1077_S_MORE_S_FOFF_L_Flash_On_L_Onp_L_Receive_RT, TR_I1072_S_LESS_L_Onp_L_Receive_RT, -1 }; /* D1039_L_Onp*/
static const TR_PL_ID PE_PossiblyEnabled_15[6]= {TR_I1079_S_MORE_S_FOFF_L_Onp_L_Receive_RT, TR_I1078_S_MORE_S_FOFF_L_Flash_Off_L_Onp_L_Receive_RT, TR_I1077_S_MORE_S_FOFF_L_Flash_On_L_Onp_L_Receive_RT, TR_I1072_S_LESS_L_Onp_L_Receive_RT, TR_D1039_L_Onp_RT, -1 }; /* D991_L_On*/
static const TR_PL_ID PE_PossiblyEnabled_16[4]= {TR_I1077_S_MORE_S_FOFF_L_Flash_On_L_Onp_L_Receive_RT, TR_I1069_S_FON_L_Off_RT, TR_D984_L_Flash_On_RT, -1 }; /* D899_L_Flash_Off*/
static const TR_PL_ID PE_PossiblyEnabled_17[4]= {TR_I1078_S_MORE_S_FOFF_L_Flash_Off_L_Onp_L_Receive_RT, TR_I1070_S_FON_L_Off_RT, TR_D899_L_Flash_Off_RT, -1 }; /* D984_L_Flash_On*/
const TR_PL_ID* SPN::PossiblyEnabled[] = {PE_PossiblyEnabled_0, PE_PossiblyEnabled_1, PE_PossiblyEnabled_2, PE_PossiblyEnabled_3, PE_PossiblyEnabled_4, PE_PossiblyEnabled_5, PE_PossiblyEnabled_6, PE_PossiblyEnabled_7, PE_PossiblyEnabled_8, PE_PossiblyEnabled_9, PE_PossiblyEnabled_10, PE_PossiblyEnabled_11, PE_PossiblyEnabled_12, PE_PossiblyEnabled_13, PE_PossiblyEnabled_14, PE_PossiblyEnabled_15, PE_PossiblyEnabled_16, PE_PossiblyEnabled_17};

static const TR_PL_ID PE_PossiblyDisabled_0[2]= {TR_RSREC1029__RT, -1 }; /* EMPTY_SREC*/
static const TR_PL_ID PE_PossiblyDisabled_2[3]= {TR_I1072_S_LESS_L_Onp_L_Receive_RT, TR_D1039_L_Onp_RT, -1 }; /* I1079_S_MORE_S_FOFF_L_Onp_L_Receive*/
static const TR_PL_ID PE_PossiblyDisabled_3[4]= {TR_I1072_S_LESS_L_Onp_L_Receive_RT, TR_D1039_L_Onp_RT, TR_D899_L_Flash_Off_RT, -1 }; /* I1078_S_MORE_S_FOFF_L_Flash_Off_L_Onp_L_Receive*/
static const TR_PL_ID PE_PossiblyDisabled_4[4]= {TR_I1072_S_LESS_L_Onp_L_Receive_RT, TR_D1039_L_Onp_RT, TR_D984_L_Flash_On_RT, -1 }; /* I1077_S_MORE_S_FOFF_L_Flash_On_L_Onp_L_Receive*/
static const TR_PL_ID PE_PossiblyDisabled_5[2]= {TR_D891_Off_RT, -1 }; /* I1075_S_LESS_L_Receive*/
static const TR_PL_ID PE_PossiblyDisabled_6[2]= {TR_D991_L_On_RT, -1 }; /* I1073_S_LESS_L_Receive*/
static const TR_PL_ID PE_PossiblyDisabled_7[5]= {TR_I1079_S_MORE_S_FOFF_L_Onp_L_Receive_RT, TR_I1078_S_MORE_S_FOFF_L_Flash_Off_L_Onp_L_Receive_RT, TR_I1077_S_MORE_S_FOFF_L_Flash_On_L_Onp_L_Receive_RT, TR_D1039_L_Onp_RT, -1 }; /* I1072_S_LESS_L_Onp_L_Receive*/
static const TR_PL_ID PE_PossiblyDisabled_8[3]= {TR_EMPTY_SREC_RT, TR_INCOMING_SREC_RT, -1 }; /* RSREC1029_*/
static const TR_PL_ID PE_PossiblyDisabled_10[2]= {TR_D899_L_Flash_Off_RT, -1 }; /* I1070_S_FON_L_Off*/
static const TR_PL_ID PE_PossiblyDisabled_11[2]= {TR_D984_L_Flash_On_RT, -1 }; /* I1069_S_FON_L_Off*/
static const TR_PL_ID PE_PossiblyDisabled_13[2]= {TR_I1075_S_LESS_L_Receive_RT, -1 }; /* D891_Off*/
static const TR_PL_ID PE_PossiblyDisabled_14[5]= {TR_I1079_S_MORE_S_FOFF_L_Onp_L_Receive_RT, TR_I1078_S_MORE_S_FOFF_L_Flash_Off_L_Onp_L_Receive_RT, TR_I1077_S_MORE_S_FOFF_L_Flash_On_L_Onp_L_Receive_RT, TR_I1072_S_LESS_L_Onp_L_Receive_RT, -1 }; /* D1039_L_Onp*/
static const TR_PL_ID PE_PossiblyDisabled_15[2]= {TR_I1073_S_LESS_L_Receive_RT, -1 }; /* D991_L_On*/
static const TR_PL_ID PE_PossiblyDisabled_16[3]= {TR_I1078_S_MORE_S_FOFF_L_Flash_Off_L_Onp_L_Receive_RT, TR_I1070_S_FON_L_Off_RT, -1 }; /* D899_L_Flash_Off*/
static const TR_PL_ID PE_PossiblyDisabled_17[3]= {TR_I1077_S_MORE_S_FOFF_L_Flash_On_L_Onp_L_Receive_RT, TR_I1069_S_FON_L_Off_RT, -1 }; /* D984_L_Flash_On*/
const TR_PL_ID* SPN::PossiblyDisabled[] = {PE_PossiblyDisabled_0, EMPTY_array, PE_PossiblyDisabled_2, PE_PossiblyDisabled_3, PE_PossiblyDisabled_4, PE_PossiblyDisabled_5, PE_PossiblyDisabled_6, PE_PossiblyDisabled_7, PE_PossiblyDisabled_8, EMPTY_array, PE_PossiblyDisabled_10, PE_PossiblyDisabled_11, EMPTY_array, PE_PossiblyDisabled_13, PE_PossiblyDisabled_14, PE_PossiblyDisabled_15, PE_PossiblyDisabled_16, PE_PossiblyDisabled_17};

const TR_PL_ID* SPN::FreeMarkDepT[] = {EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array};

SPN::SPN():
pl(4), tr(18) {
}

TR_PL_ID SPN::getIncomingTrans(){ return TR_INCOMING_SREC_RT;};

bool SPN::IsEnabled(TR_PL_ID t)const{
	if(!magicConditional(t))return false;

	switch (t){
		case 8:	//RSREC1029_

			if (!(contains(Marking.P->_PL_SIG_SREC , 1))) return false;
			if( Marking.P->_PL_SerialPort != 1025) return false;
		return true;
		break;
		case 0:	//EMPTY_SREC

			if (!(contains(Marking.P->_PL_SIG_SREC , 1))) return false;
		return true;
		break;
		case 5:	//I1075_S_LESS_L_Receive

			if( Marking.P->_PL_Controller != 886) return false;
			if( Marking.P->_PL_SerialPort != 1021) return false;
		return true;
		break;
		case 13:	//D891_Off

			if( Marking.P->_PL_Controller != 886) return false;
		return true;
		break;
		case 6:	//I1073_S_LESS_L_Receive

			if( Marking.P->_PL_Controller != 887) return false;
			if( Marking.P->_PL_SerialPort != 1021) return false;
		return true;
		break;
		case 15:	//D991_L_On

			if( Marking.P->_PL_Controller != 887) return false;
		return true;
		break;
		case 7:	//I1072_S_LESS_L_Onp_L_Receive

			if( Marking.P->_PL_Controller != 990) return false;
			if( Marking.P->_PL_SerialPort != 1021) return false;
		return true;
		break;
		case 14:	//D1039_L_Onp

			if( Marking.P->_PL_Controller != 990) return false;
		return true;
		break;
		case 10:	//I1070_S_FON_L_Off

			if( Marking.P->_PL_Led != 897) return false;
			if( Marking.P->_PL_Controller != 1040) return false;
		return true;
		break;
		case 3:	//I1078_S_MORE_S_FOFF_L_Flash_Off_L_Onp_L_Receive

			if( Marking.P->_PL_Led != 897) return false;
			if( Marking.P->_PL_Controller != 990) return false;
			if( Marking.P->_PL_SerialPort != 1021) return false;
		return true;
		break;
		case 16:	//D899_L_Flash_Off

			if( Marking.P->_PL_Led != 897) return false;
		return true;
		break;
		case 12:	//I1066_S_FON_L_Off_L_Off

			if( Marking.P->_PL_Led != 898) return false;
			if( Marking.P->_PL_Controller != 1040) return false;
		return true;
		break;
		case 2:	//I1079_S_MORE_S_FOFF_L_Onp_L_Receive

			if( Marking.P->_PL_Led != 898) return false;
			if( Marking.P->_PL_Controller != 990) return false;
			if( Marking.P->_PL_SerialPort != 1021) return false;
		return true;
		break;
		case 11:	//I1069_S_FON_L_Off

			if( Marking.P->_PL_Led != 983) return false;
			if( Marking.P->_PL_Controller != 1040) return false;
		return true;
		break;
		case 4:	//I1077_S_MORE_S_FOFF_L_Flash_On_L_Onp_L_Receive

			if( Marking.P->_PL_Led != 983) return false;
			if( Marking.P->_PL_Controller != 990) return false;
			if( Marking.P->_PL_SerialPort != 1021) return false;
		return true;
		break;
		case 17:	//D984_L_Flash_On

			if( Marking.P->_PL_Led != 983) return false;
		return true;
		break;
		case 9:	//I1082_L_NoData

			if( Marking.P->_PL_SerialPort != 1081) return false;
		return true;
		break;
		case 1:	//INCOMING_SREC

    if (Marking.P->_PL_SIG_SREC >= 0) return false;
		return true;
		break;
	}
}

void SPN::fire(TR_PL_ID t,REAL_TYPE time){
	lastTransition = t;
	magicUpdate(t,time);

	switch (t){
		case 13:	//D891_Off
{
			Marking.P->_PL_Controller -= 886;
			Marking.P->_PL_Controller += 1040;
	}
		break;
		case 5:	//I1075_S_LESS_L_Receive
{
			Marking.P->_PL_Controller -= 886;
			Marking.P->_PL_Controller += 886;
			Marking.P->_PL_SerialPort -= 1021;
			Marking.P->_PL_SerialPort += 1025;
	}
		break;
		case 6:	//I1073_S_LESS_L_Receive
{
			Marking.P->_PL_Controller -= 887;
			Marking.P->_PL_Controller += 887;
			Marking.P->_PL_SerialPort -= 1021;
			Marking.P->_PL_SerialPort += 1025;
	}
		break;
		case 15:	//D991_L_On
{
			Marking.P->_PL_Controller -= 887;
			Marking.P->_PL_Controller += 990;
	}
		break;
		case 7:	//I1072_S_LESS_L_Onp_L_Receive
{
			Marking.P->_PL_Controller -= 990;
			Marking.P->_PL_Controller += 887;
			Marking.P->_PL_SerialPort -= 1021;
			Marking.P->_PL_SerialPort += 1025;
	}
		break;
		case 14:	//D1039_L_Onp
{
			Marking.P->_PL_Controller -= 990;
			Marking.P->_PL_Controller += 990;
	}
		break;
		case 10:	//I1070_S_FON_L_Off
{
			Marking.P->_PL_Led -= 897;
			Marking.P->_PL_Led += 897;
			Marking.P->_PL_Controller -= 1040;
			Marking.P->_PL_Controller += 887;
	}
		break;
		case 3:	//I1078_S_MORE_S_FOFF_L_Flash_Off_L_Onp_L_Receive
{
			Marking.P->_PL_Led -= 897;
			Marking.P->_PL_Led += 898;
			Marking.P->_PL_Controller -= 990;
			Marking.P->_PL_Controller += 886;
			Marking.P->_PL_SerialPort -= 1021;
			Marking.P->_PL_SerialPort += 1025;
	}
		break;
		case 16:	//D899_L_Flash_Off
{
			Marking.P->_PL_Led -= 897;
			Marking.P->_PL_Led += 983;
	}
		break;
		case 12:	//I1066_S_FON_L_Off_L_Off
{
			Marking.P->_PL_Led -= 898;
			Marking.P->_PL_Led += 897;
			Marking.P->_PL_Controller -= 1040;
			Marking.P->_PL_Controller += 887;
	}
		break;
		case 2:	//I1079_S_MORE_S_FOFF_L_Onp_L_Receive
{
			Marking.P->_PL_Led -= 898;
			Marking.P->_PL_Led += 898;
			Marking.P->_PL_Controller -= 990;
			Marking.P->_PL_Controller += 886;
			Marking.P->_PL_SerialPort -= 1021;
			Marking.P->_PL_SerialPort += 1025;
	}
		break;
		case 17:	//D984_L_Flash_On
{
			Marking.P->_PL_Led -= 983;
			Marking.P->_PL_Led += 897;
	}
		break;
		case 4:	//I1077_S_MORE_S_FOFF_L_Flash_On_L_Onp_L_Receive
{
			Marking.P->_PL_Led -= 983;
			Marking.P->_PL_Led += 898;
			Marking.P->_PL_Controller -= 990;
			Marking.P->_PL_Controller += 886;
			Marking.P->_PL_SerialPort -= 1021;
			Marking.P->_PL_SerialPort += 1025;
	}
		break;
		case 11:	//I1069_S_FON_L_Off
{
			Marking.P->_PL_Led -= 983;
			Marking.P->_PL_Led += 983;
			Marking.P->_PL_Controller -= 1040;
			Marking.P->_PL_Controller += 887;
	}
		break;
		case 1:	//INCOMING_SREC
{
			Marking.P->_PL_SIG_SREC += 1;
	}
		break;
		case 8:	//RSREC1029_
{
			Marking.P->_PL_SIG_SREC -= 1;
			Marking.P->_PL_SIG_SREC += 1;
			Marking.P->_PL_SerialPort -= 1025;
			Marking.P->_PL_SerialPort += 1081;
	}
		break;
		case 0:	//EMPTY_SREC
{
			Marking.P->_PL_SIG_SREC -= 1;
	}
		break;
		case 9:	//I1082_L_NoData
{
			Marking.P->_PL_SerialPort -= 1081;
			Marking.P->_PL_SerialPort += 1021;
	}
		break;
	}
}

void SPN::setConditionsVector(){
}
void SPN::GetDistParameters(TR_PL_ID t)const{
using namespace hybridVar;

	switch (t){
		case 16:	//D899_L_Flash_Off
		case 17:	//D984_L_Flash_On
	{
		ParamDistr[0]= ( double ) 100 ;
	}

		break;
		case 14:	//D1039_L_Onp
	{
		ParamDistr[0]= ( double ) 1000 ;
	}

		break;
		case 13:	//D891_Off
	{
		ParamDistr[0]= ( double ) T_ON ;
	}

		break;
		case 15:	//D991_L_On
	{
		ParamDistr[0]= ( double ) T_POLL ;
	}

		break;
		default:	//EMPTY_SREC,INCOMING_SREC,I1079_S_MORE_S_FOFF_L_Onp_L_Receive,I1078_S_MORE_S_FOFF_L_Flash_Off_L_Onp_L_Receive,I1077_S_MORE_S_FOFF_L_Flash_On_L_Onp_L_Receive,I1075_S_LESS_L_Receive,I1073_S_LESS_L_Receive,I1072_S_LESS_L_Onp_L_Receive,RSREC1029_,I1082_L_NoData,I1070_S_FON_L_Off,I1069_S_FON_L_Off,I1066_S_FON_L_Off_L_Off,
	{
		ParamDistr[0]= ( double ) 0 ;
	}

		break;
	}
}

REAL_TYPE SPN::GetPriority(TR_PL_ID t)const{
using namespace hybridVar;

	switch (t){
		case 16:	//D899_L_Flash_Off
		case 17:	//D984_L_Flash_On
		return (double)0.98 ;
		break;
		case 13:	//D891_Off
		case 14:	//D1039_L_Onp
		case 15:	//D991_L_On
		return (double)0.99 ;
		break;
		case 10:	//I1070_S_FON_L_Off
		case 11:	//I1069_S_FON_L_Off
		case 12:	//I1066_S_FON_L_Off_L_Off
		return (double)1.99 ;
		break;
		case 0:	//EMPTY_SREC
		return (double)3 ;
		break;
		case 8:	//RSREC1029_
		return (double)3.99 ;
		break;
		case 1:	//INCOMING_SREC
		return (double)5 ;
		break;
		default:	//I1079_S_MORE_S_FOFF_L_Onp_L_Receive,I1078_S_MORE_S_FOFF_L_Flash_Off_L_Onp_L_Receive,I1077_S_MORE_S_FOFF_L_Flash_On_L_Onp_L_Receive,I1075_S_LESS_L_Receive,I1073_S_LESS_L_Receive,I1072_S_LESS_L_Onp_L_Receive,I1082_L_NoData,
		return (double)1.97 ;
		break;
	}
}

REAL_TYPE SPN::GetWeight(TR_PL_ID t)const{
using namespace hybridVar;

		return (double)1 ;
}

void SPN::reset() {
	lastTransitionTime = 0;
	Marking.resetToInitMarking();
}

