#include "spnLight.hpp"
#define PL_SIG_AP_LP 0
#define PL_SIG_AS_LP 1
#define PL_SIG_RLRI_LP 2
#define PL_SIG_SREC_LP 3
#define PL_SIG_VP_LP 4
#define PL_SIG_VS_LP 5
#define PL_SIG_Vget_LP 6
#define PL_TAVIcmp_LP 7
#define PL_AVI_LP 8
#define PL_URI_LP 9
#define PL_PVARP_LP 10
#define PL_SerialPort_LP 11
#define PL_PaceLedVentricle_LP 12
#define PL_PaceLedAtrium_LP 13
#define PL_VRP_LP 14
#define PL_LRI_LP 15
#define TR_EMPTY_AP_RT 0
#define TR_EMPTY_AS_RT 1
#define TR_EMPTY_RLRI_RT 2
#define TR_EMPTY_SREC_RT 3
#define TR_EMPTY_VP_RT 4
#define TR_EMPTY_VS_RT 5
#define TR_EMPTY_Vget_RT 6
#define TR_INCOMING_SREC_RT 7
#define TR_D888_LRI_RT 8
#define TR_I992_L_LRI_RT 9
#define TR_RAS891__RT 10
#define TR_I1102_L_LRI_RT 11
#define TR_RRLRI892__RT 12
#define TR_I1100_L_ASensed_RT 13
#define TR_RRLRI893__RT 14
#define TR_I1098_RLRI_RT 15
#define TR_I990_L_LRI_RT 16
#define TR_D923_L_VRP_RT 17
#define TR_RVP926__RT 18
#define TR_I1096_L_Idle_RT 19
#define TR_I927_L_Vsig_RT 20
#define TR_RVget928__RT 21
#define TR_I1094_L_Idle_RT 22
#define TR_I984_init_RT 23
#define TR_D969_L_On_RT 24
#define TR_RAP964__RT 25
#define TR_I1092_L_Off_RT 26
#define TR_I982_init_RT 27
#define TR_D974_L_On_RT 28
#define TR_RVP975__RT 29
#define TR_I1090_L_Off_RT 30
#define TR_I1052_S_Aget_L_Receive_RT 31
#define TR_I1051_S_Aget_L_Receive_RT 32
#define TR_I1050_S_Aget_L_Idle_L_Receive_RT 33
#define TR_I956_L_Receive_RT 34
#define TR_RSREC959__RT 35
#define TR_I1088_L_NoData_RT 36
#define TR_RVP938__RT 37
#define TR_I1086_L_Idle_RT 38
#define TR_RVS939__RT 39
#define TR_I1084_L_Idle_RT 40
#define TR_D941_L_PVARP_RT 41
#define TR_I942_L_Asig_RT 42
#define TR_D944_L_PVAB_RT 43
#define TR_RAP1076_S_RTAVI_L_Idle0_RT 44
#define TR_RAS1075_S_RTAVI_L_Idle0_RT 45
#define TR_RAP1074_S_RTAVI_L_Idle1_RT 46
#define TR_RAS1073_S_RTAVI_L_Idle1_RT 47
#define TR_I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI_RT 48
#define TR_I1071_S_TAVI_L_q0_RT 49
#define TR_I1070_S_TAVI_L_q0_RT 50
#define TR_I1069_S_TAVI_L_q0_RT 51
#define TR_I1068_S_TAVI_L_q0_L_AVI0_RT 52
#define TR_RAP1067_S_RTAVI_L_q1_L_Idle0_RT 53
#define TR_RAS1066_S_RTAVI_L_q1_L_Idle0_RT 54
#define TR_RAP1065_S_RTAVI_L_q1_L_Idle1_RT 55
#define TR_RAS1064_S_RTAVI_L_q1_L_Idle1_RT 56
#define TR_I1062_S_IncrClk_L_q1_RT 57
#define TR_I1061_S_IncrClk_L_q1_RT 58
#define TR_RVS1060_S_RURI_L_WaitURI_RURI_RT 59
#define TR_RVS1059_S_RURI_L_AVI0_RURI_RT 60
#define TR_RVS1057_S_RURI_L_AVI1_RURI_RT 61
#define TR_I1056_S_IncrClk_L_WaitURI_L_q1_RT 62
#define TR_I1055_S_IncrClk_L_AVI0_L_q1_RT 63
#define TR_I1054_S_IncrClk_L_Idle0_L_q1_RT 64
#define TR_I988_L_URI_RT 65
#define TR_D900_L_URI_RT 66
#define TR_D931_q0_RT 67

const int _nb_Place_SIG_AP=0;
const int _nb_Place_SIG_AS=1;
const int _nb_Place_SIG_RLRI=2;
const int _nb_Place_SIG_SREC=3;
const int _nb_Place_SIG_VP=4;
const int _nb_Place_SIG_VS=5;
const int _nb_Place_SIG_Vget=6;
const int _nb_Place_TAVIcmp=7;
const int _nb_Place_AVI=8;
const int _nb_Place_URI=9;
const int _nb_Place_PVARP=10;
const int _nb_Place_SerialPort=11;
const int _nb_Place_PaceLedVentricle=12;
const int _nb_Place_PaceLedAtrium=13;
const int _nb_Place_VRP=14;
const int _nb_Place_LRI=15;
namespace hybridVar {
}
#include "magic.hpp"
#include "markingImpl.hpp"

void abstractMarking::resetToInitMarking(){
	magicReset();
	P->_PL_SIG_AP =0;
	P->_PL_SIG_AS =0;
	P->_PL_SIG_RLRI =0;
	P->_PL_SIG_SREC =0;
	P->_PL_SIG_VP =0;
	P->_PL_SIG_VS =0;
	P->_PL_SIG_Vget =0;
	P->_PL_TAVIcmp =930;
	P->_PL_AVI =907;
	P->_PL_URI =897;
	P->_PL_PVARP =934;
	P->_PL_SerialPort =949;
	P->_PL_PaceLedVentricle =981;
	P->_PL_PaceLedAtrium =983;
	P->_PL_VRP =906;
	P->_PL_LRI =886;
}


abstractMarking::abstractMarking() {
	P= new abstractMarkingImpl;
	resetToInitMarking();
}

abstractMarking::~abstractMarking() {
	delete(P);
}


static const TR_PL_ID EMPTY_array[1]={-1};
static const TR_PL_ID PE_PossiblyEnabled_0[2]= {TR_I992_L_LRI_RT, -1 }; /* EMPTY_AP*/
static const TR_PL_ID PE_PossiblyEnabled_1[2]= {TR_I942_L_Asig_RT, -1 }; /* EMPTY_AS*/
static const TR_PL_ID PE_PossiblyEnabled_2[4]= {TR_I927_L_Vsig_RT, TR_I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI_RT, TR_I1056_S_IncrClk_L_WaitURI_L_q1_RT, -1 }; /* EMPTY_RLRI*/
static const TR_PL_ID PE_PossiblyEnabled_3[2]= {TR_INCOMING_SREC_RT, -1 }; /* EMPTY_SREC*/
static const TR_PL_ID PE_PossiblyEnabled_4[3]= {TR_I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI_RT, TR_I1056_S_IncrClk_L_WaitURI_L_q1_RT, -1 }; /* EMPTY_VP*/
static const TR_PL_ID PE_PossiblyEnabled_5[2]= {TR_I927_L_Vsig_RT, -1 }; /* EMPTY_VS*/
static const TR_PL_ID PE_PossiblyEnabled_6[2]= {TR_I956_L_Receive_RT, -1 }; /* EMPTY_Vget*/
static const TR_PL_ID PE_PossiblyEnabled_7[3]= {TR_EMPTY_SREC_RT, TR_RSREC959__RT, -1 }; /* INCOMING_SREC*/
static const TR_PL_ID PE_PossiblyEnabled_8[2]= {TR_I992_L_LRI_RT, -1 }; /* D888_LRI*/
static const TR_PL_ID PE_PossiblyEnabled_9[10]= {TR_EMPTY_AP_RT, TR_D888_LRI_RT, TR_RAS891__RT, TR_RRLRI893__RT, TR_RAP964__RT, TR_RAP1076_S_RTAVI_L_Idle0_RT, TR_RAP1074_S_RTAVI_L_Idle1_RT, TR_RAP1067_S_RTAVI_L_q1_L_Idle0_RT, TR_RAP1065_S_RTAVI_L_q1_L_Idle1_RT, -1 }; /* I992_L_LRI*/
static const TR_PL_ID PE_PossiblyEnabled_10[8]= {TR_EMPTY_AS_RT, TR_I1102_L_LRI_RT, TR_I942_L_Asig_RT, TR_RAS1075_S_RTAVI_L_Idle0_RT, TR_RAS1073_S_RTAVI_L_Idle1_RT, TR_RAS1066_S_RTAVI_L_q1_L_Idle0_RT, TR_RAS1064_S_RTAVI_L_q1_L_Idle1_RT, -1 }; /* RAS891_*/
static const TR_PL_ID PE_PossiblyEnabled_11[2]= {TR_RRLRI892__RT, -1 }; /* I1102_L_LRI*/
static const TR_PL_ID PE_PossiblyEnabled_12[7]= {TR_EMPTY_RLRI_RT, TR_I1100_L_ASensed_RT, TR_RRLRI893__RT, TR_I927_L_Vsig_RT, TR_I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI_RT, TR_I1056_S_IncrClk_L_WaitURI_L_q1_RT, -1 }; /* RRLRI892_*/
static const TR_PL_ID PE_PossiblyEnabled_13[4]= {TR_D888_LRI_RT, TR_RAS891__RT, TR_RRLRI893__RT, -1 }; /* I1100_L_ASensed*/
static const TR_PL_ID PE_PossiblyEnabled_14[7]= {TR_EMPTY_RLRI_RT, TR_RRLRI892__RT, TR_I1098_RLRI_RT, TR_I927_L_Vsig_RT, TR_I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI_RT, TR_I1056_S_IncrClk_L_WaitURI_L_q1_RT, -1 }; /* RRLRI893_*/
static const TR_PL_ID PE_PossiblyEnabled_15[2]= {TR_I990_L_LRI_RT, -1 }; /* I1098_RLRI*/
static const TR_PL_ID PE_PossiblyEnabled_16[4]= {TR_D888_LRI_RT, TR_RAS891__RT, TR_RRLRI893__RT, -1 }; /* I990_L_LRI*/
static const TR_PL_ID PE_PossiblyEnabled_17[3]= {TR_RVP926__RT, TR_RVget928__RT, -1 }; /* D923_L_VRP*/
static const TR_PL_ID PE_PossiblyEnabled_18[7]= {TR_EMPTY_VP_RT, TR_I1096_L_Idle_RT, TR_RVP975__RT, TR_RVP938__RT, TR_I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI_RT, TR_I1056_S_IncrClk_L_WaitURI_L_q1_RT, -1 }; /* RVP926_*/
static const TR_PL_ID PE_PossiblyEnabled_19[2]= {TR_D923_L_VRP_RT, -1 }; /* I1096_L_Idle*/
static const TR_PL_ID PE_PossiblyEnabled_20[11]= {TR_EMPTY_RLRI_RT, TR_EMPTY_VS_RT, TR_RRLRI892__RT, TR_RRLRI893__RT, TR_RVP926__RT, TR_RVget928__RT, TR_RVS939__RT, TR_RVS1060_S_RURI_L_WaitURI_RURI_RT, TR_RVS1059_S_RURI_L_AVI0_RURI_RT, TR_RVS1057_S_RURI_L_AVI1_RURI_RT, -1 }; /* I927_L_Vsig*/
static const TR_PL_ID PE_PossiblyEnabled_21[4]= {TR_EMPTY_Vget_RT, TR_I1094_L_Idle_RT, TR_I956_L_Receive_RT, -1 }; /* RVget928_*/
static const TR_PL_ID PE_PossiblyEnabled_22[2]= {TR_I927_L_Vsig_RT, -1 }; /* I1094_L_Idle*/
static const TR_PL_ID PE_PossiblyEnabled_23[2]= {TR_RAP964__RT, -1 }; /* I984_init*/
static const TR_PL_ID PE_PossiblyEnabled_24[2]= {TR_RAP964__RT, -1 }; /* D969_L_On*/
static const TR_PL_ID PE_PossiblyEnabled_25[8]= {TR_EMPTY_AP_RT, TR_I992_L_LRI_RT, TR_I1092_L_Off_RT, TR_RAP1076_S_RTAVI_L_Idle0_RT, TR_RAP1074_S_RTAVI_L_Idle1_RT, TR_RAP1067_S_RTAVI_L_q1_L_Idle0_RT, TR_RAP1065_S_RTAVI_L_q1_L_Idle1_RT, -1 }; /* RAP964_*/
static const TR_PL_ID PE_PossiblyEnabled_26[2]= {TR_D969_L_On_RT, -1 }; /* I1092_L_Off*/
static const TR_PL_ID PE_PossiblyEnabled_27[2]= {TR_RVP975__RT, -1 }; /* I982_init*/
static const TR_PL_ID PE_PossiblyEnabled_28[2]= {TR_RVP975__RT, -1 }; /* D974_L_On*/
static const TR_PL_ID PE_PossiblyEnabled_29[7]= {TR_EMPTY_VP_RT, TR_RVP926__RT, TR_I1090_L_Off_RT, TR_RVP938__RT, TR_I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI_RT, TR_I1056_S_IncrClk_L_WaitURI_L_q1_RT, -1 }; /* RVP975_*/
static const TR_PL_ID PE_PossiblyEnabled_30[2]= {TR_D974_L_On_RT, -1 }; /* I1090_L_Off*/
static const TR_PL_ID PE_PossiblyEnabled_31[3]= {TR_RSREC959__RT, TR_D944_L_PVAB_RT, -1 }; /* I1052_S_Aget_L_Receive*/
static const TR_PL_ID PE_PossiblyEnabled_32[3]= {TR_RSREC959__RT, TR_D941_L_PVARP_RT, -1 }; /* I1051_S_Aget_L_Receive*/
static const TR_PL_ID PE_PossiblyEnabled_33[3]= {TR_RSREC959__RT, TR_I942_L_Asig_RT, -1 }; /* I1050_S_Aget_L_Idle_L_Receive*/
static const TR_PL_ID PE_PossiblyEnabled_34[4]= {TR_EMPTY_Vget_RT, TR_RVget928__RT, TR_RSREC959__RT, -1 }; /* I956_L_Receive*/
static const TR_PL_ID PE_PossiblyEnabled_35[4]= {TR_EMPTY_SREC_RT, TR_INCOMING_SREC_RT, TR_I1088_L_NoData_RT, -1 }; /* RSREC959_*/
static const TR_PL_ID PE_PossiblyEnabled_36[5]= {TR_I1052_S_Aget_L_Receive_RT, TR_I1051_S_Aget_L_Receive_RT, TR_I1050_S_Aget_L_Idle_L_Receive_RT, TR_I956_L_Receive_RT, -1 }; /* I1088_L_NoData*/
static const TR_PL_ID PE_PossiblyEnabled_37[7]= {TR_EMPTY_VP_RT, TR_RVP926__RT, TR_RVP975__RT, TR_I1086_L_Idle_RT, TR_I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI_RT, TR_I1056_S_IncrClk_L_WaitURI_L_q1_RT, -1 }; /* RVP938_*/
static const TR_PL_ID PE_PossiblyEnabled_38[3]= {TR_I1052_S_Aget_L_Receive_RT, TR_D944_L_PVAB_RT, -1 }; /* I1086_L_Idle*/
static const TR_PL_ID PE_PossiblyEnabled_39[7]= {TR_EMPTY_VS_RT, TR_I927_L_Vsig_RT, TR_I1084_L_Idle_RT, TR_RVS1060_S_RURI_L_WaitURI_RURI_RT, TR_RVS1059_S_RURI_L_AVI0_RURI_RT, TR_RVS1057_S_RURI_L_AVI1_RURI_RT, -1 }; /* RVS939_*/
static const TR_PL_ID PE_PossiblyEnabled_40[3]= {TR_I1052_S_Aget_L_Receive_RT, TR_D944_L_PVAB_RT, -1 }; /* I1084_L_Idle*/
static const TR_PL_ID PE_PossiblyEnabled_41[4]= {TR_I1050_S_Aget_L_Idle_L_Receive_RT, TR_RVP938__RT, TR_RVS939__RT, -1 }; /* D941_L_PVARP*/
static const TR_PL_ID PE_PossiblyEnabled_42[10]= {TR_EMPTY_AS_RT, TR_RAS891__RT, TR_I1050_S_Aget_L_Idle_L_Receive_RT, TR_RVP938__RT, TR_RVS939__RT, TR_RAS1075_S_RTAVI_L_Idle0_RT, TR_RAS1073_S_RTAVI_L_Idle1_RT, TR_RAS1066_S_RTAVI_L_q1_L_Idle0_RT, TR_RAS1064_S_RTAVI_L_q1_L_Idle1_RT, -1 }; /* I942_L_Asig*/
static const TR_PL_ID PE_PossiblyEnabled_43[3]= {TR_I1051_S_Aget_L_Receive_RT, TR_D941_L_PVARP_RT, -1 }; /* D944_L_PVAB*/
static const TR_PL_ID PE_PossiblyEnabled_44[10]= {TR_EMPTY_AP_RT, TR_I992_L_LRI_RT, TR_RAP964__RT, TR_RAP1074_S_RTAVI_L_Idle1_RT, TR_RAP1067_S_RTAVI_L_q1_L_Idle0_RT, TR_RAP1065_S_RTAVI_L_q1_L_Idle1_RT, TR_RVS1059_S_RURI_L_AVI0_RURI_RT, TR_I1055_S_IncrClk_L_AVI0_L_q1_RT, TR_D931_q0_RT, -1 }; /* RAP1076_S_RTAVI_L_Idle0*/
static const TR_PL_ID PE_PossiblyEnabled_45[10]= {TR_EMPTY_AS_RT, TR_RAS891__RT, TR_I942_L_Asig_RT, TR_RAS1073_S_RTAVI_L_Idle1_RT, TR_RAS1066_S_RTAVI_L_q1_L_Idle0_RT, TR_RAS1064_S_RTAVI_L_q1_L_Idle1_RT, TR_RVS1059_S_RURI_L_AVI0_RURI_RT, TR_I1055_S_IncrClk_L_AVI0_L_q1_RT, TR_D931_q0_RT, -1 }; /* RAS1075_S_RTAVI_L_Idle0*/
static const TR_PL_ID PE_PossiblyEnabled_46[10]= {TR_EMPTY_AP_RT, TR_I992_L_LRI_RT, TR_RAP964__RT, TR_RAP1076_S_RTAVI_L_Idle0_RT, TR_RAP1067_S_RTAVI_L_q1_L_Idle0_RT, TR_RAP1065_S_RTAVI_L_q1_L_Idle1_RT, TR_I1061_S_IncrClk_L_q1_RT, TR_RVS1057_S_RURI_L_AVI1_RURI_RT, TR_D931_q0_RT, -1 }; /* RAP1074_S_RTAVI_L_Idle1*/
static const TR_PL_ID PE_PossiblyEnabled_47[10]= {TR_EMPTY_AS_RT, TR_RAS891__RT, TR_I942_L_Asig_RT, TR_RAS1075_S_RTAVI_L_Idle0_RT, TR_RAS1066_S_RTAVI_L_q1_L_Idle0_RT, TR_RAS1064_S_RTAVI_L_q1_L_Idle1_RT, TR_I1061_S_IncrClk_L_q1_RT, TR_RVS1057_S_RURI_L_AVI1_RURI_RT, TR_D931_q0_RT, -1 }; /* RAS1073_S_RTAVI_L_Idle1*/
static const TR_PL_ID PE_PossiblyEnabled_48[12]= {TR_EMPTY_RLRI_RT, TR_EMPTY_VP_RT, TR_RRLRI892__RT, TR_RRLRI893__RT, TR_RVP926__RT, TR_RVP975__RT, TR_RVP938__RT, TR_RAP1067_S_RTAVI_L_q1_L_Idle0_RT, TR_RAS1066_S_RTAVI_L_q1_L_Idle0_RT, TR_I1056_S_IncrClk_L_WaitURI_L_q1_RT, TR_I988_L_URI_RT, -1 }; /* I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI*/
static const TR_PL_ID PE_PossiblyEnabled_49[4]= {TR_RAP1067_S_RTAVI_L_q1_L_Idle0_RT, TR_RAS1066_S_RTAVI_L_q1_L_Idle0_RT, TR_I1054_S_IncrClk_L_Idle0_L_q1_RT, -1 }; /* I1071_S_TAVI_L_q0*/
static const TR_PL_ID PE_PossiblyEnabled_50[3]= {TR_RVS1060_S_RURI_L_WaitURI_RURI_RT, TR_I1056_S_IncrClk_L_WaitURI_L_q1_RT, -1 }; /* I1070_S_TAVI_L_q0*/
static const TR_PL_ID PE_PossiblyEnabled_51[4]= {TR_RAP1065_S_RTAVI_L_q1_L_Idle1_RT, TR_RAS1064_S_RTAVI_L_q1_L_Idle1_RT, TR_I1062_S_IncrClk_L_q1_RT, -1 }; /* I1069_S_TAVI_L_q0*/
static const TR_PL_ID PE_PossiblyEnabled_52[3]= {TR_RVS1060_S_RURI_L_WaitURI_RURI_RT, TR_I1056_S_IncrClk_L_WaitURI_L_q1_RT, -1 }; /* I1068_S_TAVI_L_q0_L_AVI0*/
static const TR_PL_ID PE_PossiblyEnabled_53[10]= {TR_EMPTY_AP_RT, TR_I992_L_LRI_RT, TR_RAP964__RT, TR_RAP1076_S_RTAVI_L_Idle0_RT, TR_RAP1074_S_RTAVI_L_Idle1_RT, TR_RAP1065_S_RTAVI_L_q1_L_Idle1_RT, TR_RVS1059_S_RURI_L_AVI0_RURI_RT, TR_I1055_S_IncrClk_L_AVI0_L_q1_RT, TR_D931_q0_RT, -1 }; /* RAP1067_S_RTAVI_L_q1_L_Idle0*/
static const TR_PL_ID PE_PossiblyEnabled_54[10]= {TR_EMPTY_AS_RT, TR_RAS891__RT, TR_I942_L_Asig_RT, TR_RAS1075_S_RTAVI_L_Idle0_RT, TR_RAS1073_S_RTAVI_L_Idle1_RT, TR_RAS1064_S_RTAVI_L_q1_L_Idle1_RT, TR_RVS1059_S_RURI_L_AVI0_RURI_RT, TR_I1055_S_IncrClk_L_AVI0_L_q1_RT, TR_D931_q0_RT, -1 }; /* RAS1066_S_RTAVI_L_q1_L_Idle0*/
static const TR_PL_ID PE_PossiblyEnabled_55[10]= {TR_EMPTY_AP_RT, TR_I992_L_LRI_RT, TR_RAP964__RT, TR_RAP1076_S_RTAVI_L_Idle0_RT, TR_RAP1074_S_RTAVI_L_Idle1_RT, TR_RAP1067_S_RTAVI_L_q1_L_Idle0_RT, TR_I1061_S_IncrClk_L_q1_RT, TR_RVS1057_S_RURI_L_AVI1_RURI_RT, TR_D931_q0_RT, -1 }; /* RAP1065_S_RTAVI_L_q1_L_Idle1*/
static const TR_PL_ID PE_PossiblyEnabled_56[10]= {TR_EMPTY_AS_RT, TR_RAS891__RT, TR_I942_L_Asig_RT, TR_RAS1075_S_RTAVI_L_Idle0_RT, TR_RAS1073_S_RTAVI_L_Idle1_RT, TR_RAS1066_S_RTAVI_L_q1_L_Idle0_RT, TR_I1061_S_IncrClk_L_q1_RT, TR_RVS1057_S_RURI_L_AVI1_RURI_RT, TR_D931_q0_RT, -1 }; /* RAS1064_S_RTAVI_L_q1_L_Idle1*/
static const TR_PL_ID PE_PossiblyEnabled_57[7]= {TR_RAP1074_S_RTAVI_L_Idle1_RT, TR_RAS1073_S_RTAVI_L_Idle1_RT, TR_I1069_S_TAVI_L_q0_RT, TR_RAP1065_S_RTAVI_L_q1_L_Idle1_RT, TR_RAS1064_S_RTAVI_L_q1_L_Idle1_RT, TR_D900_L_URI_RT, -1 }; /* I1062_S_IncrClk_L_q1*/
static const TR_PL_ID PE_PossiblyEnabled_58[4]= {TR_I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI_RT, TR_RVS1057_S_RURI_L_AVI1_RURI_RT, TR_D900_L_URI_RT, -1 }; /* I1061_S_IncrClk_L_q1*/
static const TR_PL_ID PE_PossiblyEnabled_59[12]= {TR_EMPTY_VS_RT, TR_I927_L_Vsig_RT, TR_RVS939__RT, TR_RAP1076_S_RTAVI_L_Idle0_RT, TR_RAS1075_S_RTAVI_L_Idle0_RT, TR_I1071_S_TAVI_L_q0_RT, TR_RAP1067_S_RTAVI_L_q1_L_Idle0_RT, TR_RAS1066_S_RTAVI_L_q1_L_Idle0_RT, TR_RVS1059_S_RURI_L_AVI0_RURI_RT, TR_RVS1057_S_RURI_L_AVI1_RURI_RT, TR_I988_L_URI_RT, -1 }; /* RVS1060_S_RURI_L_WaitURI_RURI*/
static const TR_PL_ID PE_PossiblyEnabled_60[12]= {TR_EMPTY_VS_RT, TR_I927_L_Vsig_RT, TR_RVS939__RT, TR_RAP1076_S_RTAVI_L_Idle0_RT, TR_RAS1075_S_RTAVI_L_Idle0_RT, TR_I1071_S_TAVI_L_q0_RT, TR_RAP1067_S_RTAVI_L_q1_L_Idle0_RT, TR_RAS1066_S_RTAVI_L_q1_L_Idle0_RT, TR_RVS1060_S_RURI_L_WaitURI_RURI_RT, TR_RVS1057_S_RURI_L_AVI1_RURI_RT, TR_I988_L_URI_RT, -1 }; /* RVS1059_S_RURI_L_AVI0_RURI*/
static const TR_PL_ID PE_PossiblyEnabled_61[12]= {TR_EMPTY_VS_RT, TR_I927_L_Vsig_RT, TR_RVS939__RT, TR_RAP1076_S_RTAVI_L_Idle0_RT, TR_RAS1075_S_RTAVI_L_Idle0_RT, TR_I1071_S_TAVI_L_q0_RT, TR_RAP1067_S_RTAVI_L_q1_L_Idle0_RT, TR_RAS1066_S_RTAVI_L_q1_L_Idle0_RT, TR_RVS1060_S_RURI_L_WaitURI_RURI_RT, TR_RVS1059_S_RURI_L_AVI0_RURI_RT, TR_I988_L_URI_RT, -1 }; /* RVS1057_S_RURI_L_AVI1_RURI*/
static const TR_PL_ID PE_PossiblyEnabled_62[15]= {TR_EMPTY_RLRI_RT, TR_EMPTY_VP_RT, TR_RRLRI892__RT, TR_RRLRI893__RT, TR_RVP926__RT, TR_RVP975__RT, TR_RVP938__RT, TR_RAP1076_S_RTAVI_L_Idle0_RT, TR_RAS1075_S_RTAVI_L_Idle0_RT, TR_I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI_RT, TR_I1071_S_TAVI_L_q0_RT, TR_RAP1067_S_RTAVI_L_q1_L_Idle0_RT, TR_RAS1066_S_RTAVI_L_q1_L_Idle0_RT, TR_D900_L_URI_RT, -1 }; /* I1056_S_IncrClk_L_WaitURI_L_q1*/
static const TR_PL_ID PE_PossiblyEnabled_63[4]= {TR_I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI_RT, TR_RVS1057_S_RURI_L_AVI1_RURI_RT, TR_D900_L_URI_RT, -1 }; /* I1055_S_IncrClk_L_AVI0_L_q1*/
static const TR_PL_ID PE_PossiblyEnabled_64[7]= {TR_RAP1074_S_RTAVI_L_Idle1_RT, TR_RAS1073_S_RTAVI_L_Idle1_RT, TR_I1069_S_TAVI_L_q0_RT, TR_RAP1065_S_RTAVI_L_q1_L_Idle1_RT, TR_RAS1064_S_RTAVI_L_q1_L_Idle1_RT, TR_D900_L_URI_RT, -1 }; /* I1054_S_IncrClk_L_Idle0_L_q1*/
static const TR_PL_ID PE_PossiblyEnabled_65[6]= {TR_I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI_RT, TR_RVS1060_S_RURI_L_WaitURI_RURI_RT, TR_RVS1059_S_RURI_L_AVI0_RURI_RT, TR_RVS1057_S_RURI_L_AVI1_RURI_RT, TR_D900_L_URI_RT, -1 }; /* I988_L_URI*/
static const TR_PL_ID PE_PossiblyEnabled_66[6]= {TR_I1062_S_IncrClk_L_q1_RT, TR_I1061_S_IncrClk_L_q1_RT, TR_I1056_S_IncrClk_L_WaitURI_L_q1_RT, TR_I1055_S_IncrClk_L_AVI0_L_q1_RT, TR_I1054_S_IncrClk_L_Idle0_L_q1_RT, -1 }; /* D900_L_URI*/
static const TR_PL_ID PE_PossiblyEnabled_67[6]= {TR_I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI_RT, TR_I1071_S_TAVI_L_q0_RT, TR_I1070_S_TAVI_L_q0_RT, TR_I1069_S_TAVI_L_q0_RT, TR_I1068_S_TAVI_L_q0_L_AVI0_RT, -1 }; /* D931_q0*/
const TR_PL_ID* SPN::PossiblyEnabled[] = {PE_PossiblyEnabled_0, PE_PossiblyEnabled_1, PE_PossiblyEnabled_2, PE_PossiblyEnabled_3, PE_PossiblyEnabled_4, PE_PossiblyEnabled_5, PE_PossiblyEnabled_6, PE_PossiblyEnabled_7, PE_PossiblyEnabled_8, PE_PossiblyEnabled_9, PE_PossiblyEnabled_10, PE_PossiblyEnabled_11, PE_PossiblyEnabled_12, PE_PossiblyEnabled_13, PE_PossiblyEnabled_14, PE_PossiblyEnabled_15, PE_PossiblyEnabled_16, PE_PossiblyEnabled_17, PE_PossiblyEnabled_18, PE_PossiblyEnabled_19, PE_PossiblyEnabled_20, PE_PossiblyEnabled_21, PE_PossiblyEnabled_22, PE_PossiblyEnabled_23, PE_PossiblyEnabled_24, PE_PossiblyEnabled_25, PE_PossiblyEnabled_26, PE_PossiblyEnabled_27, PE_PossiblyEnabled_28, PE_PossiblyEnabled_29, PE_PossiblyEnabled_30, PE_PossiblyEnabled_31, PE_PossiblyEnabled_32, PE_PossiblyEnabled_33, PE_PossiblyEnabled_34, PE_PossiblyEnabled_35, PE_PossiblyEnabled_36, PE_PossiblyEnabled_37, PE_PossiblyEnabled_38, PE_PossiblyEnabled_39, PE_PossiblyEnabled_40, PE_PossiblyEnabled_41, PE_PossiblyEnabled_42, PE_PossiblyEnabled_43, PE_PossiblyEnabled_44, PE_PossiblyEnabled_45, PE_PossiblyEnabled_46, PE_PossiblyEnabled_47, PE_PossiblyEnabled_48, PE_PossiblyEnabled_49, PE_PossiblyEnabled_50, PE_PossiblyEnabled_51, PE_PossiblyEnabled_52, PE_PossiblyEnabled_53, PE_PossiblyEnabled_54, PE_PossiblyEnabled_55, PE_PossiblyEnabled_56, PE_PossiblyEnabled_57, PE_PossiblyEnabled_58, PE_PossiblyEnabled_59, PE_PossiblyEnabled_60, PE_PossiblyEnabled_61, PE_PossiblyEnabled_62, PE_PossiblyEnabled_63, PE_PossiblyEnabled_64, PE_PossiblyEnabled_65, PE_PossiblyEnabled_66, PE_PossiblyEnabled_67};

static const TR_PL_ID PE_PossiblyDisabled_0[6]= {TR_RAP964__RT, TR_RAP1076_S_RTAVI_L_Idle0_RT, TR_RAP1074_S_RTAVI_L_Idle1_RT, TR_RAP1067_S_RTAVI_L_q1_L_Idle0_RT, TR_RAP1065_S_RTAVI_L_q1_L_Idle1_RT, -1 }; /* EMPTY_AP*/
static const TR_PL_ID PE_PossiblyDisabled_1[6]= {TR_RAS891__RT, TR_RAS1075_S_RTAVI_L_Idle0_RT, TR_RAS1073_S_RTAVI_L_Idle1_RT, TR_RAS1066_S_RTAVI_L_q1_L_Idle0_RT, TR_RAS1064_S_RTAVI_L_q1_L_Idle1_RT, -1 }; /* EMPTY_AS*/
static const TR_PL_ID PE_PossiblyDisabled_2[3]= {TR_RRLRI892__RT, TR_RRLRI893__RT, -1 }; /* EMPTY_RLRI*/
static const TR_PL_ID PE_PossiblyDisabled_3[2]= {TR_RSREC959__RT, -1 }; /* EMPTY_SREC*/
static const TR_PL_ID PE_PossiblyDisabled_4[4]= {TR_RVP926__RT, TR_RVP975__RT, TR_RVP938__RT, -1 }; /* EMPTY_VP*/
static const TR_PL_ID PE_PossiblyDisabled_5[5]= {TR_RVS939__RT, TR_RVS1060_S_RURI_L_WaitURI_RURI_RT, TR_RVS1059_S_RURI_L_AVI0_RURI_RT, TR_RVS1057_S_RURI_L_AVI1_RURI_RT, -1 }; /* EMPTY_VS*/
static const TR_PL_ID PE_PossiblyDisabled_6[2]= {TR_RVget928__RT, -1 }; /* EMPTY_Vget*/
static const TR_PL_ID PE_PossiblyDisabled_8[3]= {TR_RAS891__RT, TR_RRLRI893__RT, -1 }; /* D888_LRI*/
static const TR_PL_ID PE_PossiblyDisabled_10[9]= {TR_EMPTY_AS_RT, TR_D888_LRI_RT, TR_RRLRI893__RT, TR_I942_L_Asig_RT, TR_RAS1075_S_RTAVI_L_Idle0_RT, TR_RAS1073_S_RTAVI_L_Idle1_RT, TR_RAS1066_S_RTAVI_L_q1_L_Idle0_RT, TR_RAS1064_S_RTAVI_L_q1_L_Idle1_RT, -1 }; /* RAS891_*/
static const TR_PL_ID PE_PossiblyDisabled_12[6]= {TR_EMPTY_RLRI_RT, TR_RRLRI893__RT, TR_I927_L_Vsig_RT, TR_I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI_RT, TR_I1056_S_IncrClk_L_WaitURI_L_q1_RT, -1 }; /* RRLRI892_*/
static const TR_PL_ID PE_PossiblyDisabled_14[8]= {TR_EMPTY_RLRI_RT, TR_D888_LRI_RT, TR_RAS891__RT, TR_RRLRI892__RT, TR_I927_L_Vsig_RT, TR_I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI_RT, TR_I1056_S_IncrClk_L_WaitURI_L_q1_RT, -1 }; /* RRLRI893_*/
static const TR_PL_ID PE_PossiblyDisabled_18[7]= {TR_EMPTY_VP_RT, TR_RVget928__RT, TR_RVP975__RT, TR_RVP938__RT, TR_I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI_RT, TR_I1056_S_IncrClk_L_WaitURI_L_q1_RT, -1 }; /* RVP926_*/
static const TR_PL_ID PE_PossiblyDisabled_20[3]= {TR_I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI_RT, TR_I1056_S_IncrClk_L_WaitURI_L_q1_RT, -1 }; /* I927_L_Vsig*/
static const TR_PL_ID PE_PossiblyDisabled_21[4]= {TR_EMPTY_Vget_RT, TR_RVP926__RT, TR_I956_L_Receive_RT, -1 }; /* RVget928_*/
static const TR_PL_ID PE_PossiblyDisabled_25[7]= {TR_EMPTY_AP_RT, TR_I992_L_LRI_RT, TR_RAP1076_S_RTAVI_L_Idle0_RT, TR_RAP1074_S_RTAVI_L_Idle1_RT, TR_RAP1067_S_RTAVI_L_q1_L_Idle0_RT, TR_RAP1065_S_RTAVI_L_q1_L_Idle1_RT, -1 }; /* RAP964_*/
static const TR_PL_ID PE_PossiblyDisabled_29[6]= {TR_EMPTY_VP_RT, TR_RVP926__RT, TR_RVP938__RT, TR_I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI_RT, TR_I1056_S_IncrClk_L_WaitURI_L_q1_RT, -1 }; /* RVP975_*/
static const TR_PL_ID PE_PossiblyDisabled_31[3]= {TR_I956_L_Receive_RT, TR_D944_L_PVAB_RT, -1 }; /* I1052_S_Aget_L_Receive*/
static const TR_PL_ID PE_PossiblyDisabled_32[3]= {TR_I956_L_Receive_RT, TR_D941_L_PVARP_RT, -1 }; /* I1051_S_Aget_L_Receive*/
static const TR_PL_ID PE_PossiblyDisabled_33[4]= {TR_I956_L_Receive_RT, TR_RVP938__RT, TR_RVS939__RT, -1 }; /* I1050_S_Aget_L_Idle_L_Receive*/
static const TR_PL_ID PE_PossiblyDisabled_34[4]= {TR_I1052_S_Aget_L_Receive_RT, TR_I1051_S_Aget_L_Receive_RT, TR_I1050_S_Aget_L_Idle_L_Receive_RT, -1 }; /* I956_L_Receive*/
static const TR_PL_ID PE_PossiblyDisabled_35[3]= {TR_EMPTY_SREC_RT, TR_INCOMING_SREC_RT, -1 }; /* RSREC959_*/
static const TR_PL_ID PE_PossiblyDisabled_37[8]= {TR_EMPTY_VP_RT, TR_RVP926__RT, TR_RVP975__RT, TR_I1050_S_Aget_L_Idle_L_Receive_RT, TR_RVS939__RT, TR_I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI_RT, TR_I1056_S_IncrClk_L_WaitURI_L_q1_RT, -1 }; /* RVP938_*/
static const TR_PL_ID PE_PossiblyDisabled_39[8]= {TR_EMPTY_VS_RT, TR_I927_L_Vsig_RT, TR_I1050_S_Aget_L_Idle_L_Receive_RT, TR_RVP938__RT, TR_RVS1060_S_RURI_L_WaitURI_RURI_RT, TR_RVS1059_S_RURI_L_AVI0_RURI_RT, TR_RVS1057_S_RURI_L_AVI1_RURI_RT, -1 }; /* RVS939_*/
static const TR_PL_ID PE_PossiblyDisabled_41[2]= {TR_I1051_S_Aget_L_Receive_RT, -1 }; /* D941_L_PVARP*/
static const TR_PL_ID PE_PossiblyDisabled_43[2]= {TR_I1052_S_Aget_L_Receive_RT, -1 }; /* D944_L_PVAB*/
static const TR_PL_ID PE_PossiblyDisabled_44[10]= {TR_EMPTY_AP_RT, TR_I992_L_LRI_RT, TR_RAP964__RT, TR_RAS1075_S_RTAVI_L_Idle0_RT, TR_RAP1074_S_RTAVI_L_Idle1_RT, TR_RAP1067_S_RTAVI_L_q1_L_Idle0_RT, TR_RAP1065_S_RTAVI_L_q1_L_Idle1_RT, TR_I1054_S_IncrClk_L_Idle0_L_q1_RT, TR_D931_q0_RT, -1 }; /* RAP1076_S_RTAVI_L_Idle0*/
static const TR_PL_ID PE_PossiblyDisabled_45[10]= {TR_EMPTY_AS_RT, TR_RAS891__RT, TR_I942_L_Asig_RT, TR_RAP1076_S_RTAVI_L_Idle0_RT, TR_RAS1073_S_RTAVI_L_Idle1_RT, TR_RAS1066_S_RTAVI_L_q1_L_Idle0_RT, TR_RAS1064_S_RTAVI_L_q1_L_Idle1_RT, TR_I1054_S_IncrClk_L_Idle0_L_q1_RT, TR_D931_q0_RT, -1 }; /* RAS1075_S_RTAVI_L_Idle0*/
static const TR_PL_ID PE_PossiblyDisabled_46[10]= {TR_EMPTY_AP_RT, TR_I992_L_LRI_RT, TR_RAP964__RT, TR_RAP1076_S_RTAVI_L_Idle0_RT, TR_RAS1073_S_RTAVI_L_Idle1_RT, TR_RAP1067_S_RTAVI_L_q1_L_Idle0_RT, TR_RAP1065_S_RTAVI_L_q1_L_Idle1_RT, TR_I1062_S_IncrClk_L_q1_RT, TR_D931_q0_RT, -1 }; /* RAP1074_S_RTAVI_L_Idle1*/
static const TR_PL_ID PE_PossiblyDisabled_47[10]= {TR_EMPTY_AS_RT, TR_RAS891__RT, TR_I942_L_Asig_RT, TR_RAS1075_S_RTAVI_L_Idle0_RT, TR_RAP1074_S_RTAVI_L_Idle1_RT, TR_RAS1066_S_RTAVI_L_q1_L_Idle0_RT, TR_RAS1064_S_RTAVI_L_q1_L_Idle1_RT, TR_I1062_S_IncrClk_L_q1_RT, TR_D931_q0_RT, -1 }; /* RAS1073_S_RTAVI_L_Idle1*/
static const TR_PL_ID PE_PossiblyDisabled_48[5]= {TR_I927_L_Vsig_RT, TR_RVS1057_S_RURI_L_AVI1_RURI_RT, TR_I1056_S_IncrClk_L_WaitURI_L_q1_RT, TR_D900_L_URI_RT, -1 }; /* I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI*/
static const TR_PL_ID PE_PossiblyDisabled_49[2]= {TR_I1054_S_IncrClk_L_Idle0_L_q1_RT, -1 }; /* I1071_S_TAVI_L_q0*/
static const TR_PL_ID PE_PossiblyDisabled_50[3]= {TR_RVS1060_S_RURI_L_WaitURI_RURI_RT, TR_I1056_S_IncrClk_L_WaitURI_L_q1_RT, -1 }; /* I1070_S_TAVI_L_q0*/
static const TR_PL_ID PE_PossiblyDisabled_51[2]= {TR_I1062_S_IncrClk_L_q1_RT, -1 }; /* I1069_S_TAVI_L_q0*/
static const TR_PL_ID PE_PossiblyDisabled_52[3]= {TR_RVS1059_S_RURI_L_AVI0_RURI_RT, TR_I1055_S_IncrClk_L_AVI0_L_q1_RT, -1 }; /* I1068_S_TAVI_L_q0_L_AVI0*/
static const TR_PL_ID PE_PossiblyDisabled_53[9]= {TR_EMPTY_AP_RT, TR_I992_L_LRI_RT, TR_RAP964__RT, TR_RAP1076_S_RTAVI_L_Idle0_RT, TR_RAP1074_S_RTAVI_L_Idle1_RT, TR_RAS1066_S_RTAVI_L_q1_L_Idle0_RT, TR_RAP1065_S_RTAVI_L_q1_L_Idle1_RT, TR_I1054_S_IncrClk_L_Idle0_L_q1_RT, -1 }; /* RAP1067_S_RTAVI_L_q1_L_Idle0*/
static const TR_PL_ID PE_PossiblyDisabled_54[9]= {TR_EMPTY_AS_RT, TR_RAS891__RT, TR_I942_L_Asig_RT, TR_RAS1075_S_RTAVI_L_Idle0_RT, TR_RAS1073_S_RTAVI_L_Idle1_RT, TR_RAP1067_S_RTAVI_L_q1_L_Idle0_RT, TR_RAS1064_S_RTAVI_L_q1_L_Idle1_RT, TR_I1054_S_IncrClk_L_Idle0_L_q1_RT, -1 }; /* RAS1066_S_RTAVI_L_q1_L_Idle0*/
static const TR_PL_ID PE_PossiblyDisabled_55[9]= {TR_EMPTY_AP_RT, TR_I992_L_LRI_RT, TR_RAP964__RT, TR_RAP1076_S_RTAVI_L_Idle0_RT, TR_RAP1074_S_RTAVI_L_Idle1_RT, TR_RAP1067_S_RTAVI_L_q1_L_Idle0_RT, TR_RAS1064_S_RTAVI_L_q1_L_Idle1_RT, TR_I1062_S_IncrClk_L_q1_RT, -1 }; /* RAP1065_S_RTAVI_L_q1_L_Idle1*/
static const TR_PL_ID PE_PossiblyDisabled_56[9]= {TR_EMPTY_AS_RT, TR_RAS891__RT, TR_I942_L_Asig_RT, TR_RAS1075_S_RTAVI_L_Idle0_RT, TR_RAS1073_S_RTAVI_L_Idle1_RT, TR_RAS1066_S_RTAVI_L_q1_L_Idle0_RT, TR_RAP1065_S_RTAVI_L_q1_L_Idle1_RT, TR_I1062_S_IncrClk_L_q1_RT, -1 }; /* RAS1064_S_RTAVI_L_q1_L_Idle1*/
static const TR_PL_ID PE_PossiblyDisabled_57[6]= {TR_RAP1074_S_RTAVI_L_Idle1_RT, TR_RAS1073_S_RTAVI_L_Idle1_RT, TR_I1069_S_TAVI_L_q0_RT, TR_RAP1065_S_RTAVI_L_q1_L_Idle1_RT, TR_RAS1064_S_RTAVI_L_q1_L_Idle1_RT, -1 }; /* I1062_S_IncrClk_L_q1*/
static const TR_PL_ID PE_PossiblyDisabled_59[8]= {TR_EMPTY_VS_RT, TR_I927_L_Vsig_RT, TR_RVS939__RT, TR_I1070_S_TAVI_L_q0_RT, TR_RVS1059_S_RURI_L_AVI0_RURI_RT, TR_RVS1057_S_RURI_L_AVI1_RURI_RT, TR_D900_L_URI_RT, -1 }; /* RVS1060_S_RURI_L_WaitURI_RURI*/
static const TR_PL_ID PE_PossiblyDisabled_60[8]= {TR_EMPTY_VS_RT, TR_I927_L_Vsig_RT, TR_RVS939__RT, TR_I1068_S_TAVI_L_q0_L_AVI0_RT, TR_RVS1060_S_RURI_L_WaitURI_RURI_RT, TR_RVS1057_S_RURI_L_AVI1_RURI_RT, TR_D900_L_URI_RT, -1 }; /* RVS1059_S_RURI_L_AVI0_RURI*/
static const TR_PL_ID PE_PossiblyDisabled_61[8]= {TR_EMPTY_VS_RT, TR_I927_L_Vsig_RT, TR_RVS939__RT, TR_I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI_RT, TR_RVS1060_S_RURI_L_WaitURI_RURI_RT, TR_RVS1059_S_RURI_L_AVI0_RURI_RT, TR_D900_L_URI_RT, -1 }; /* RVS1057_S_RURI_L_AVI1_RURI*/
static const TR_PL_ID PE_PossiblyDisabled_62[4]= {TR_I927_L_Vsig_RT, TR_I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI_RT, TR_I1070_S_TAVI_L_q0_RT, -1 }; /* I1056_S_IncrClk_L_WaitURI_L_q1*/
static const TR_PL_ID PE_PossiblyDisabled_63[2]= {TR_I1068_S_TAVI_L_q0_L_AVI0_RT, -1 }; /* I1055_S_IncrClk_L_AVI0_L_q1*/
static const TR_PL_ID PE_PossiblyDisabled_64[6]= {TR_RAP1076_S_RTAVI_L_Idle0_RT, TR_RAS1075_S_RTAVI_L_Idle0_RT, TR_I1071_S_TAVI_L_q0_RT, TR_RAP1067_S_RTAVI_L_q1_L_Idle0_RT, TR_RAS1066_S_RTAVI_L_q1_L_Idle0_RT, -1 }; /* I1054_S_IncrClk_L_Idle0_L_q1*/
static const TR_PL_ID PE_PossiblyDisabled_66[5]= {TR_I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI_RT, TR_RVS1060_S_RURI_L_WaitURI_RURI_RT, TR_RVS1059_S_RURI_L_AVI0_RURI_RT, TR_RVS1057_S_RURI_L_AVI1_RURI_RT, -1 }; /* D900_L_URI*/
static const TR_PL_ID PE_PossiblyDisabled_67[5]= {TR_RAP1076_S_RTAVI_L_Idle0_RT, TR_RAS1075_S_RTAVI_L_Idle0_RT, TR_RAP1074_S_RTAVI_L_Idle1_RT, TR_RAS1073_S_RTAVI_L_Idle1_RT, -1 }; /* D931_q0*/
const TR_PL_ID* SPN::PossiblyDisabled[] = {PE_PossiblyDisabled_0, PE_PossiblyDisabled_1, PE_PossiblyDisabled_2, PE_PossiblyDisabled_3, PE_PossiblyDisabled_4, PE_PossiblyDisabled_5, PE_PossiblyDisabled_6, EMPTY_array, PE_PossiblyDisabled_8, EMPTY_array, PE_PossiblyDisabled_10, EMPTY_array, PE_PossiblyDisabled_12, EMPTY_array, PE_PossiblyDisabled_14, EMPTY_array, EMPTY_array, EMPTY_array, PE_PossiblyDisabled_18, EMPTY_array, PE_PossiblyDisabled_20, PE_PossiblyDisabled_21, EMPTY_array, EMPTY_array, EMPTY_array, PE_PossiblyDisabled_25, EMPTY_array, EMPTY_array, EMPTY_array, PE_PossiblyDisabled_29, EMPTY_array, PE_PossiblyDisabled_31, PE_PossiblyDisabled_32, PE_PossiblyDisabled_33, PE_PossiblyDisabled_34, PE_PossiblyDisabled_35, EMPTY_array, PE_PossiblyDisabled_37, EMPTY_array, PE_PossiblyDisabled_39, EMPTY_array, PE_PossiblyDisabled_41, EMPTY_array, PE_PossiblyDisabled_43, PE_PossiblyDisabled_44, PE_PossiblyDisabled_45, PE_PossiblyDisabled_46, PE_PossiblyDisabled_47, PE_PossiblyDisabled_48, PE_PossiblyDisabled_49, PE_PossiblyDisabled_50, PE_PossiblyDisabled_51, PE_PossiblyDisabled_52, PE_PossiblyDisabled_53, PE_PossiblyDisabled_54, PE_PossiblyDisabled_55, PE_PossiblyDisabled_56, PE_PossiblyDisabled_57, EMPTY_array, PE_PossiblyDisabled_59, PE_PossiblyDisabled_60, PE_PossiblyDisabled_61, PE_PossiblyDisabled_62, PE_PossiblyDisabled_63, PE_PossiblyDisabled_64, EMPTY_array, PE_PossiblyDisabled_66, PE_PossiblyDisabled_67};

const TR_PL_ID* SPN::FreeMarkDepT[] = {EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array, EMPTY_array};

SPN::SPN():
pl(16), tr(68) {
}

TR_PL_ID SPN::getIncomingTrans(){ return TR_INCOMING_SREC_RT;};

bool SPN::IsEnabled(TR_PL_ID t)const{
	if(!magicConditional(t))return false;

	switch (t){
		case 25:	//RAP964_

			if (!(contains(Marking.P->_PL_SIG_AP , 1))) return false;
			if( Marking.P->_PL_PaceLedAtrium != 961) return false;
		return true;
		break;
		case 46:	//RAP1074_S_RTAVI_L_Idle1

			if (!(contains(Marking.P->_PL_SIG_AP , 1))) return false;
			if( Marking.P->_PL_TAVIcmp != 929) return false;
			if( Marking.P->_PL_AVI != 895) return false;
		return true;
		break;
		case 44:	//RAP1076_S_RTAVI_L_Idle0

			if (!(contains(Marking.P->_PL_SIG_AP , 1))) return false;
			if( Marking.P->_PL_TAVIcmp != 929) return false;
			if( Marking.P->_PL_AVI != 907) return false;
		return true;
		break;
		case 55:	//RAP1065_S_RTAVI_L_q1_L_Idle1

			if (!(contains(Marking.P->_PL_SIG_AP , 1))) return false;
			if( Marking.P->_PL_TAVIcmp != 930) return false;
			if( Marking.P->_PL_AVI != 895) return false;
		return true;
		break;
		case 53:	//RAP1067_S_RTAVI_L_q1_L_Idle0

			if (!(contains(Marking.P->_PL_SIG_AP , 1))) return false;
			if( Marking.P->_PL_TAVIcmp != 930) return false;
			if( Marking.P->_PL_AVI != 907) return false;
		return true;
		break;
		case 0:	//EMPTY_AP

			if (!(contains(Marking.P->_PL_SIG_AP , 1))) return false;
		return true;
		break;
		case 10:	//RAS891_

			if (!(contains(Marking.P->_PL_SIG_AS , 1))) return false;
			if( Marking.P->_PL_LRI != 886) return false;
		return true;
		break;
		case 47:	//RAS1073_S_RTAVI_L_Idle1

			if (!(contains(Marking.P->_PL_SIG_AS , 1))) return false;
			if( Marking.P->_PL_TAVIcmp != 929) return false;
			if( Marking.P->_PL_AVI != 895) return false;
		return true;
		break;
		case 45:	//RAS1075_S_RTAVI_L_Idle0

			if (!(contains(Marking.P->_PL_SIG_AS , 1))) return false;
			if( Marking.P->_PL_TAVIcmp != 929) return false;
			if( Marking.P->_PL_AVI != 907) return false;
		return true;
		break;
		case 56:	//RAS1064_S_RTAVI_L_q1_L_Idle1

			if (!(contains(Marking.P->_PL_SIG_AS , 1))) return false;
			if( Marking.P->_PL_TAVIcmp != 930) return false;
			if( Marking.P->_PL_AVI != 895) return false;
		return true;
		break;
		case 54:	//RAS1066_S_RTAVI_L_q1_L_Idle0

			if (!(contains(Marking.P->_PL_SIG_AS , 1))) return false;
			if( Marking.P->_PL_TAVIcmp != 930) return false;
			if( Marking.P->_PL_AVI != 907) return false;
		return true;
		break;
		case 1:	//EMPTY_AS

			if (!(contains(Marking.P->_PL_SIG_AS , 1))) return false;
		return true;
		break;
		case 14:	//RRLRI893_

			if (!(contains(Marking.P->_PL_SIG_RLRI , 1))) return false;
			if( Marking.P->_PL_LRI != 886) return false;
		return true;
		break;
		case 12:	//RRLRI892_

			if (!(contains(Marking.P->_PL_SIG_RLRI , 1))) return false;
			if( Marking.P->_PL_LRI != 887) return false;
		return true;
		break;
		case 2:	//EMPTY_RLRI

			if (!(contains(Marking.P->_PL_SIG_RLRI , 1))) return false;
		return true;
		break;
		case 35:	//RSREC959_

			if (!(contains(Marking.P->_PL_SIG_SREC , 1))) return false;
			if( Marking.P->_PL_SerialPort != 949) return false;
		return true;
		break;
		case 3:	//EMPTY_SREC

			if (!(contains(Marking.P->_PL_SIG_SREC , 1))) return false;
		return true;
		break;
		case 37:	//RVP938_

			if (!(contains(Marking.P->_PL_SIG_VP , 1))) return false;
			if( Marking.P->_PL_PVARP != 934) return false;
		return true;
		break;
		case 29:	//RVP975_

			if (!(contains(Marking.P->_PL_SIG_VP , 1))) return false;
			if( Marking.P->_PL_PaceLedVentricle != 973) return false;
		return true;
		break;
		case 18:	//RVP926_

			if (!(contains(Marking.P->_PL_SIG_VP , 1))) return false;
			if( Marking.P->_PL_VRP != 906) return false;
		return true;
		break;
		case 4:	//EMPTY_VP

			if (!(contains(Marking.P->_PL_SIG_VP , 1))) return false;
		return true;
		break;
		case 60:	//RVS1059_S_RURI_L_AVI0_RURI

			if (!(contains(Marking.P->_PL_SIG_VS , 1))) return false;
			if( Marking.P->_PL_AVI != 908) return false;
			if( Marking.P->_PL_URI != 897) return false;
		return true;
		break;
		case 59:	//RVS1060_S_RURI_L_WaitURI_RURI

			if (!(contains(Marking.P->_PL_SIG_VS , 1))) return false;
			if( Marking.P->_PL_AVI != 909) return false;
			if( Marking.P->_PL_URI != 897) return false;
		return true;
		break;
		case 61:	//RVS1057_S_RURI_L_AVI1_RURI

			if (!(contains(Marking.P->_PL_SIG_VS , 1))) return false;
			if( Marking.P->_PL_AVI != 911) return false;
			if( Marking.P->_PL_URI != 897) return false;
		return true;
		break;
		case 39:	//RVS939_

			if (!(contains(Marking.P->_PL_SIG_VS , 1))) return false;
			if( Marking.P->_PL_PVARP != 934) return false;
		return true;
		break;
		case 5:	//EMPTY_VS

			if (!(contains(Marking.P->_PL_SIG_VS , 1))) return false;
		return true;
		break;
		case 21:	//RVget928_

			if (!(contains(Marking.P->_PL_SIG_Vget , 1))) return false;
			if( Marking.P->_PL_VRP != 906) return false;
		return true;
		break;
		case 6:	//EMPTY_Vget

			if (!(contains(Marking.P->_PL_SIG_Vget , 1))) return false;
		return true;
		break;
		case 57:	//I1062_S_IncrClk_L_q1

			if( Marking.P->_PL_AVI != 895) return false;
			if( Marking.P->_PL_URI != 898) return false;
		return true;
		break;
		case 64:	//I1054_S_IncrClk_L_Idle0_L_q1

			if( Marking.P->_PL_AVI != 907) return false;
			if( Marking.P->_PL_URI != 898) return false;
		return true;
		break;
		case 63:	//I1055_S_IncrClk_L_AVI0_L_q1

			if( Marking.P->_PL_AVI != 908) return false;
			if( Marking.P->_PL_URI != 898) return false;
		return true;
		break;
		case 58:	//I1061_S_IncrClk_L_q1

			if( Marking.P->_PL_AVI != 911) return false;
			if( Marking.P->_PL_URI != 898) return false;
		return true;
		break;
		case 15:	//I1098_RLRI

			if( Marking.P->_PL_LRI != 1097) return false;
		return true;
		break;
		case 13:	//I1100_L_ASensed

			if( Marking.P->_PL_LRI != 1099) return false;
		return true;
		break;
		case 11:	//I1102_L_LRI

			if( Marking.P->_PL_LRI != 1101) return false;
		return true;
		break;
		case 8:	//D888_LRI

			if( Marking.P->_PL_LRI != 886) return false;
		return true;
		break;
		case 16:	//I990_L_LRI

			if( Marking.P->_PL_LRI != 989) return false;
		return true;
		break;
		case 40:	//I1084_L_Idle

			if( Marking.P->_PL_PVARP != 1083) return false;
		return true;
		break;
		case 38:	//I1086_L_Idle

			if( Marking.P->_PL_PVARP != 1085) return false;
		return true;
		break;
		case 33:	//I1050_S_Aget_L_Idle_L_Receive

			if( Marking.P->_PL_PVARP != 934) return false;
			if( Marking.P->_PL_SerialPort != 955) return false;
		return true;
		break;
		case 31:	//I1052_S_Aget_L_Receive

			if( Marking.P->_PL_PVARP != 935) return false;
			if( Marking.P->_PL_SerialPort != 955) return false;
		return true;
		break;
		case 43:	//D944_L_PVAB

			if( Marking.P->_PL_PVARP != 935) return false;
		return true;
		break;
		case 32:	//I1051_S_Aget_L_Receive

			if( Marking.P->_PL_PVARP != 937) return false;
			if( Marking.P->_PL_SerialPort != 955) return false;
		return true;
		break;
		case 41:	//D941_L_PVARP

			if( Marking.P->_PL_PVARP != 937) return false;
		return true;
		break;
		case 26:	//I1092_L_Off

			if( Marking.P->_PL_PaceLedAtrium != 1091) return false;
		return true;
		break;
		case 24:	//D969_L_On

			if( Marking.P->_PL_PaceLedAtrium != 963) return false;
		return true;
		break;
		case 23:	//I984_init

			if( Marking.P->_PL_PaceLedAtrium != 983) return false;
		return true;
		break;
		case 30:	//I1090_L_Off

			if( Marking.P->_PL_PaceLedVentricle != 1089) return false;
		return true;
		break;
		case 28:	//D974_L_On

			if( Marking.P->_PL_PaceLedVentricle != 971) return false;
		return true;
		break;
		case 27:	//I982_init

			if( Marking.P->_PL_PaceLedVentricle != 981) return false;
		return true;
		break;
		case 36:	//I1088_L_NoData

			if( Marking.P->_PL_SerialPort != 1087) return false;
		return true;
		break;
		case 67:	//D931_q0

			if( Marking.P->_PL_TAVIcmp != 929) return false;
		return true;
		break;
		case 51:	//I1069_S_TAVI_L_q0

			if( Marking.P->_PL_TAVIcmp != 985) return false;
			if( Marking.P->_PL_AVI != 895) return false;
		return true;
		break;
		case 49:	//I1071_S_TAVI_L_q0

			if( Marking.P->_PL_TAVIcmp != 985) return false;
			if( Marking.P->_PL_AVI != 907) return false;
		return true;
		break;
		case 52:	//I1068_S_TAVI_L_q0_L_AVI0

			if( Marking.P->_PL_TAVIcmp != 985) return false;
			if( Marking.P->_PL_AVI != 908) return false;
		return true;
		break;
		case 50:	//I1070_S_TAVI_L_q0

			if( Marking.P->_PL_TAVIcmp != 985) return false;
			if( Marking.P->_PL_AVI != 909) return false;
		return true;
		break;
		case 66:	//D900_L_URI

			if( Marking.P->_PL_URI != 897) return false;
		return true;
		break;
		case 65:	//I988_L_URI

			if( Marking.P->_PL_URI != 987) return false;
		return true;
		break;
		case 22:	//I1094_L_Idle

			if( Marking.P->_PL_VRP != 1093) return false;
		return true;
		break;
		case 19:	//I1096_L_Idle

			if( Marking.P->_PL_VRP != 1095) return false;
		return true;
		break;
		case 17:	//D923_L_VRP

			if( Marking.P->_PL_VRP != 924) return false;
		return true;
		break;
		case 9:	//I992_L_LRI

    if (Marking.P->_PL_SIG_AP >= 1) return false;
			if( Marking.P->_PL_LRI != 991) return false;
		return true;
		break;
		case 42:	//I942_L_Asig

    if (Marking.P->_PL_SIG_AS >= 1) return false;
			if( Marking.P->_PL_PVARP != 936) return false;
		return true;
		break;
		case 62:	//I1056_S_IncrClk_L_WaitURI_L_q1

    if (Marking.P->_PL_SIG_RLRI >= 1) return false;
    if (Marking.P->_PL_SIG_VP >= 1) return false;
			if( Marking.P->_PL_AVI != 909) return false;
			if( Marking.P->_PL_URI != 898) return false;
		return true;
		break;
		case 48:	//I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI

    if (Marking.P->_PL_SIG_RLRI >= 1) return false;
    if (Marking.P->_PL_SIG_VP >= 1) return false;
			if( Marking.P->_PL_TAVIcmp != 985) return false;
			if( Marking.P->_PL_AVI != 911) return false;
			if( Marking.P->_PL_URI != 897) return false;
		return true;
		break;
		case 20:	//I927_L_Vsig

    if (Marking.P->_PL_SIG_RLRI >= 1) return false;
    if (Marking.P->_PL_SIG_VS >= 1) return false;
			if( Marking.P->_PL_VRP != 925) return false;
		return true;
		break;
		case 7:	//INCOMING_SREC

    if (Marking.P->_PL_SIG_SREC >= 0) return false;
		return true;
		break;
		case 34:	//I956_L_Receive

    if (Marking.P->_PL_SIG_Vget >= 1) return false;
			if( Marking.P->_PL_SerialPort != 955) return false;
		return true;
		break;
	}
}

void SPN::fire(TR_PL_ID t,REAL_TYPE time){
	lastTransition = t;
	magicUpdate(t,time);

	switch (t){
		case 57:	//I1062_S_IncrClk_L_q1
{
			Marking.P->_PL_AVI -= 895;
			Marking.P->_PL_AVI += 895;
			Marking.P->_PL_URI -= 898;
			Marking.P->_PL_URI += 897;
	}
		break;
		case 64:	//I1054_S_IncrClk_L_Idle0_L_q1
{
			Marking.P->_PL_AVI -= 907;
			Marking.P->_PL_AVI += 895;
			Marking.P->_PL_URI -= 898;
			Marking.P->_PL_URI += 897;
	}
		break;
		case 63:	//I1055_S_IncrClk_L_AVI0_L_q1
{
			Marking.P->_PL_AVI -= 908;
			Marking.P->_PL_AVI += 911;
			Marking.P->_PL_URI -= 898;
			Marking.P->_PL_URI += 897;
	}
		break;
		case 58:	//I1061_S_IncrClk_L_q1
{
			Marking.P->_PL_AVI -= 911;
			Marking.P->_PL_AVI += 911;
			Marking.P->_PL_URI -= 898;
			Marking.P->_PL_URI += 897;
	}
		break;
		case 15:	//I1098_RLRI
{
			Marking.P->_PL_LRI -= 1097;
			Marking.P->_PL_LRI += 989;
	}
		break;
		case 13:	//I1100_L_ASensed
{
			Marking.P->_PL_LRI -= 1099;
			Marking.P->_PL_LRI += 886;
	}
		break;
		case 11:	//I1102_L_LRI
{
			Marking.P->_PL_LRI -= 1101;
			Marking.P->_PL_LRI += 887;
	}
		break;
		case 8:	//D888_LRI
{
			Marking.P->_PL_LRI -= 886;
			Marking.P->_PL_LRI += 991;
	}
		break;
		case 16:	//I990_L_LRI
{
			Marking.P->_PL_LRI -= 989;
			Marking.P->_PL_LRI += 886;
	}
		break;
		case 40:	//I1084_L_Idle
{
			Marking.P->_PL_PVARP -= 1083;
			Marking.P->_PL_PVARP += 935;
	}
		break;
		case 38:	//I1086_L_Idle
{
			Marking.P->_PL_PVARP -= 1085;
			Marking.P->_PL_PVARP += 935;
	}
		break;
		case 33:	//I1050_S_Aget_L_Idle_L_Receive
{
			Marking.P->_PL_PVARP -= 934;
			Marking.P->_PL_PVARP += 936;
			Marking.P->_PL_SerialPort -= 955;
			Marking.P->_PL_SerialPort += 949;
	}
		break;
		case 31:	//I1052_S_Aget_L_Receive
{
			Marking.P->_PL_PVARP -= 935;
			Marking.P->_PL_PVARP += 935;
			Marking.P->_PL_SerialPort -= 955;
			Marking.P->_PL_SerialPort += 949;
	}
		break;
		case 43:	//D944_L_PVAB
{
			Marking.P->_PL_PVARP -= 935;
			Marking.P->_PL_PVARP += 937;
	}
		break;
		case 41:	//D941_L_PVARP
{
			Marking.P->_PL_PVARP -= 937;
			Marking.P->_PL_PVARP += 934;
	}
		break;
		case 32:	//I1051_S_Aget_L_Receive
{
			Marking.P->_PL_PVARP -= 937;
			Marking.P->_PL_PVARP += 937;
			Marking.P->_PL_SerialPort -= 955;
			Marking.P->_PL_SerialPort += 949;
	}
		break;
		case 26:	//I1092_L_Off
{
			Marking.P->_PL_PaceLedAtrium -= 1091;
			Marking.P->_PL_PaceLedAtrium += 963;
	}
		break;
		case 24:	//D969_L_On
{
			Marking.P->_PL_PaceLedAtrium -= 963;
			Marking.P->_PL_PaceLedAtrium += 961;
	}
		break;
		case 23:	//I984_init
{
			Marking.P->_PL_PaceLedAtrium -= 983;
			Marking.P->_PL_PaceLedAtrium += 961;
	}
		break;
		case 30:	//I1090_L_Off
{
			Marking.P->_PL_PaceLedVentricle -= 1089;
			Marking.P->_PL_PaceLedVentricle += 971;
	}
		break;
		case 28:	//D974_L_On
{
			Marking.P->_PL_PaceLedVentricle -= 971;
			Marking.P->_PL_PaceLedVentricle += 973;
	}
		break;
		case 27:	//I982_init
{
			Marking.P->_PL_PaceLedVentricle -= 981;
			Marking.P->_PL_PaceLedVentricle += 973;
	}
		break;
		case 9:	//I992_L_LRI
{
			Marking.P->_PL_SIG_AP += 1;
			Marking.P->_PL_LRI -= 991;
			Marking.P->_PL_LRI += 886;
	}
		break;
		case 25:	//RAP964_
{
			Marking.P->_PL_SIG_AP -= 1;
			Marking.P->_PL_SIG_AP += 1;
			Marking.P->_PL_PaceLedAtrium -= 961;
			Marking.P->_PL_PaceLedAtrium += 1091;
	}
		break;
		case 46:	//RAP1074_S_RTAVI_L_Idle1
{
			Marking.P->_PL_SIG_AP -= 1;
			Marking.P->_PL_SIG_AP += 1;
			Marking.P->_PL_TAVIcmp -= 929;
			Marking.P->_PL_TAVIcmp += 929;
			Marking.P->_PL_AVI -= 895;
			Marking.P->_PL_AVI += 911;
	}
		break;
		case 44:	//RAP1076_S_RTAVI_L_Idle0
{
			Marking.P->_PL_SIG_AP -= 1;
			Marking.P->_PL_SIG_AP += 1;
			Marking.P->_PL_TAVIcmp -= 929;
			Marking.P->_PL_TAVIcmp += 929;
			Marking.P->_PL_AVI -= 907;
			Marking.P->_PL_AVI += 908;
	}
		break;
		case 55:	//RAP1065_S_RTAVI_L_q1_L_Idle1
{
			Marking.P->_PL_SIG_AP -= 1;
			Marking.P->_PL_SIG_AP += 1;
			Marking.P->_PL_TAVIcmp -= 930;
			Marking.P->_PL_TAVIcmp += 929;
			Marking.P->_PL_AVI -= 895;
			Marking.P->_PL_AVI += 911;
	}
		break;
		case 53:	//RAP1067_S_RTAVI_L_q1_L_Idle0
{
			Marking.P->_PL_SIG_AP -= 1;
			Marking.P->_PL_SIG_AP += 1;
			Marking.P->_PL_TAVIcmp -= 930;
			Marking.P->_PL_TAVIcmp += 929;
			Marking.P->_PL_AVI -= 907;
			Marking.P->_PL_AVI += 908;
	}
		break;
		case 0:	//EMPTY_AP
{
			Marking.P->_PL_SIG_AP -= 1;
	}
		break;
		case 42:	//I942_L_Asig
{
			Marking.P->_PL_SIG_AS += 1;
			Marking.P->_PL_PVARP -= 936;
			Marking.P->_PL_PVARP += 934;
	}
		break;
		case 10:	//RAS891_
{
			Marking.P->_PL_SIG_AS -= 1;
			Marking.P->_PL_SIG_AS += 1;
			Marking.P->_PL_LRI -= 886;
			Marking.P->_PL_LRI += 1101;
	}
		break;
		case 47:	//RAS1073_S_RTAVI_L_Idle1
{
			Marking.P->_PL_SIG_AS -= 1;
			Marking.P->_PL_SIG_AS += 1;
			Marking.P->_PL_TAVIcmp -= 929;
			Marking.P->_PL_TAVIcmp += 929;
			Marking.P->_PL_AVI -= 895;
			Marking.P->_PL_AVI += 911;
	}
		break;
		case 45:	//RAS1075_S_RTAVI_L_Idle0
{
			Marking.P->_PL_SIG_AS -= 1;
			Marking.P->_PL_SIG_AS += 1;
			Marking.P->_PL_TAVIcmp -= 929;
			Marking.P->_PL_TAVIcmp += 929;
			Marking.P->_PL_AVI -= 907;
			Marking.P->_PL_AVI += 908;
	}
		break;
		case 56:	//RAS1064_S_RTAVI_L_q1_L_Idle1
{
			Marking.P->_PL_SIG_AS -= 1;
			Marking.P->_PL_SIG_AS += 1;
			Marking.P->_PL_TAVIcmp -= 930;
			Marking.P->_PL_TAVIcmp += 929;
			Marking.P->_PL_AVI -= 895;
			Marking.P->_PL_AVI += 911;
	}
		break;
		case 54:	//RAS1066_S_RTAVI_L_q1_L_Idle0
{
			Marking.P->_PL_SIG_AS -= 1;
			Marking.P->_PL_SIG_AS += 1;
			Marking.P->_PL_TAVIcmp -= 930;
			Marking.P->_PL_TAVIcmp += 929;
			Marking.P->_PL_AVI -= 907;
			Marking.P->_PL_AVI += 908;
	}
		break;
		case 1:	//EMPTY_AS
{
			Marking.P->_PL_SIG_AS -= 1;
	}
		break;
		case 62:	//I1056_S_IncrClk_L_WaitURI_L_q1
{
			Marking.P->_PL_SIG_RLRI += 1;
			Marking.P->_PL_SIG_VP += 1;
			Marking.P->_PL_AVI -= 909;
			Marking.P->_PL_AVI += 907;
			Marking.P->_PL_URI -= 898;
			Marking.P->_PL_URI += 897;
	}
		break;
		case 48:	//I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI
{
			Marking.P->_PL_SIG_RLRI += 1;
			Marking.P->_PL_SIG_VP += 1;
			Marking.P->_PL_TAVIcmp -= 985;
			Marking.P->_PL_TAVIcmp += 930;
			Marking.P->_PL_AVI -= 911;
			Marking.P->_PL_AVI += 907;
			Marking.P->_PL_URI -= 897;
			Marking.P->_PL_URI += 987;
	}
		break;
		case 20:	//I927_L_Vsig
{
			Marking.P->_PL_SIG_RLRI += 1;
			Marking.P->_PL_SIG_VS += 1;
			Marking.P->_PL_VRP -= 925;
			Marking.P->_PL_VRP += 906;
	}
		break;
		case 14:	//RRLRI893_
{
			Marking.P->_PL_SIG_RLRI -= 1;
			Marking.P->_PL_SIG_RLRI += 1;
			Marking.P->_PL_LRI -= 886;
			Marking.P->_PL_LRI += 1097;
	}
		break;
		case 12:	//RRLRI892_
{
			Marking.P->_PL_SIG_RLRI -= 1;
			Marking.P->_PL_SIG_RLRI += 1;
			Marking.P->_PL_LRI -= 887;
			Marking.P->_PL_LRI += 1099;
	}
		break;
		case 2:	//EMPTY_RLRI
{
			Marking.P->_PL_SIG_RLRI -= 1;
	}
		break;
		case 7:	//INCOMING_SREC
{
			Marking.P->_PL_SIG_SREC += 1;
	}
		break;
		case 35:	//RSREC959_
{
			Marking.P->_PL_SIG_SREC -= 1;
			Marking.P->_PL_SIG_SREC += 1;
			Marking.P->_PL_SerialPort -= 949;
			Marking.P->_PL_SerialPort += 1087;
	}
		break;
		case 3:	//EMPTY_SREC
{
			Marking.P->_PL_SIG_SREC -= 1;
	}
		break;
		case 37:	//RVP938_
{
			Marking.P->_PL_SIG_VP -= 1;
			Marking.P->_PL_SIG_VP += 1;
			Marking.P->_PL_PVARP -= 934;
			Marking.P->_PL_PVARP += 1085;
	}
		break;
		case 29:	//RVP975_
{
			Marking.P->_PL_SIG_VP -= 1;
			Marking.P->_PL_SIG_VP += 1;
			Marking.P->_PL_PaceLedVentricle -= 973;
			Marking.P->_PL_PaceLedVentricle += 1089;
	}
		break;
		case 18:	//RVP926_
{
			Marking.P->_PL_SIG_VP -= 1;
			Marking.P->_PL_SIG_VP += 1;
			Marking.P->_PL_VRP -= 906;
			Marking.P->_PL_VRP += 1095;
	}
		break;
		case 4:	//EMPTY_VP
{
			Marking.P->_PL_SIG_VP -= 1;
	}
		break;
		case 60:	//RVS1059_S_RURI_L_AVI0_RURI
{
			Marking.P->_PL_SIG_VS -= 1;
			Marking.P->_PL_SIG_VS += 1;
			Marking.P->_PL_AVI -= 908;
			Marking.P->_PL_AVI += 907;
			Marking.P->_PL_URI -= 897;
			Marking.P->_PL_URI += 987;
	}
		break;
		case 59:	//RVS1060_S_RURI_L_WaitURI_RURI
{
			Marking.P->_PL_SIG_VS -= 1;
			Marking.P->_PL_SIG_VS += 1;
			Marking.P->_PL_AVI -= 909;
			Marking.P->_PL_AVI += 907;
			Marking.P->_PL_URI -= 897;
			Marking.P->_PL_URI += 987;
	}
		break;
		case 61:	//RVS1057_S_RURI_L_AVI1_RURI
{
			Marking.P->_PL_SIG_VS -= 1;
			Marking.P->_PL_SIG_VS += 1;
			Marking.P->_PL_AVI -= 911;
			Marking.P->_PL_AVI += 907;
			Marking.P->_PL_URI -= 897;
			Marking.P->_PL_URI += 987;
	}
		break;
		case 39:	//RVS939_
{
			Marking.P->_PL_SIG_VS -= 1;
			Marking.P->_PL_SIG_VS += 1;
			Marking.P->_PL_PVARP -= 934;
			Marking.P->_PL_PVARP += 1083;
	}
		break;
		case 5:	//EMPTY_VS
{
			Marking.P->_PL_SIG_VS -= 1;
	}
		break;
		case 34:	//I956_L_Receive
{
			Marking.P->_PL_SIG_Vget += 1;
			Marking.P->_PL_SerialPort -= 955;
			Marking.P->_PL_SerialPort += 949;
	}
		break;
		case 21:	//RVget928_
{
			Marking.P->_PL_SIG_Vget -= 1;
			Marking.P->_PL_SIG_Vget += 1;
			Marking.P->_PL_VRP -= 906;
			Marking.P->_PL_VRP += 1093;
	}
		break;
		case 6:	//EMPTY_Vget
{
			Marking.P->_PL_SIG_Vget -= 1;
	}
		break;
		case 36:	//I1088_L_NoData
{
			Marking.P->_PL_SerialPort -= 1087;
			Marking.P->_PL_SerialPort += 955;
	}
		break;
		case 67:	//D931_q0
{
			Marking.P->_PL_TAVIcmp -= 929;
			Marking.P->_PL_TAVIcmp += 985;
	}
		break;
		case 51:	//I1069_S_TAVI_L_q0
{
			Marking.P->_PL_TAVIcmp -= 985;
			Marking.P->_PL_TAVIcmp += 930;
			Marking.P->_PL_AVI -= 895;
			Marking.P->_PL_AVI += 895;
	}
		break;
		case 49:	//I1071_S_TAVI_L_q0
{
			Marking.P->_PL_TAVIcmp -= 985;
			Marking.P->_PL_TAVIcmp += 930;
			Marking.P->_PL_AVI -= 907;
			Marking.P->_PL_AVI += 907;
	}
		break;
		case 52:	//I1068_S_TAVI_L_q0_L_AVI0
{
			Marking.P->_PL_TAVIcmp -= 985;
			Marking.P->_PL_TAVIcmp += 930;
			Marking.P->_PL_AVI -= 908;
			Marking.P->_PL_AVI += 909;
	}
		break;
		case 50:	//I1070_S_TAVI_L_q0
{
			Marking.P->_PL_TAVIcmp -= 985;
			Marking.P->_PL_TAVIcmp += 930;
			Marking.P->_PL_AVI -= 909;
			Marking.P->_PL_AVI += 909;
	}
		break;
		case 66:	//D900_L_URI
{
			Marking.P->_PL_URI -= 897;
			Marking.P->_PL_URI += 898;
	}
		break;
		case 65:	//I988_L_URI
{
			Marking.P->_PL_URI -= 987;
			Marking.P->_PL_URI += 897;
	}
		break;
		case 22:	//I1094_L_Idle
{
			Marking.P->_PL_VRP -= 1093;
			Marking.P->_PL_VRP += 925;
	}
		break;
		case 19:	//I1096_L_Idle
{
			Marking.P->_PL_VRP -= 1095;
			Marking.P->_PL_VRP += 924;
	}
		break;
		case 17:	//D923_L_VRP
{
			Marking.P->_PL_VRP -= 924;
			Marking.P->_PL_VRP += 906;
	}
		break;
	}
}

void SPN::setConditionsVector(){
}
void SPN::GetDistParameters(TR_PL_ID t)const{
using namespace hybridVar;

	switch (t){
		case 8:	//D888_LRI
	{
		ParamDistr[0]= ( double )  (PM_TLRI  - PM_TAVI ) ;
	}

		break;
		case 41:	//D941_L_PVARP
	{
		ParamDistr[0]= ( double )  (PM_TPVARP  - PM_TPVAB ) ;
	}

		break;
		case 24:	//D969_L_On
		case 28:	//D974_L_On
	{
		ParamDistr[0]= ( double ) 10 ;
	}

		break;
		case 67:	//D931_q0
	{
		ParamDistr[0]= ( double ) PM_TAVI ;
	}

		break;
		case 43:	//D944_L_PVAB
	{
		ParamDistr[0]= ( double ) PM_TPVAB ;
	}

		break;
		case 66:	//D900_L_URI
	{
		ParamDistr[0]= ( double ) PM_TURI ;
	}

		break;
		case 17:	//D923_L_VRP
	{
		ParamDistr[0]= ( double ) PM_TVRP ;
	}

		break;
		default:	//EMPTY_AP,EMPTY_AS,EMPTY_RLRI,EMPTY_SREC,EMPTY_VP,EMPTY_VS,EMPTY_Vget,INCOMING_SREC,I992_L_LRI,RAS891_,I1102_L_LRI,RRLRI892_,I1100_L_ASensed,RRLRI893_,I1098_RLRI,I990_L_LRI,RVP926_,I1096_L_Idle,I927_L_Vsig,RVget928_,I1094_L_Idle,I984_init,RAP964_,I1092_L_Off,I982_init,RVP975_,I1090_L_Off,I1052_S_Aget_L_Receive,I1051_S_Aget_L_Receive,I1050_S_Aget_L_Idle_L_Receive,I956_L_Receive,RSREC959_,I1088_L_NoData,RVP938_,I1086_L_Idle,RVS939_,I1084_L_Idle,I942_L_Asig,RAP1076_S_RTAVI_L_Idle0,RAS1075_S_RTAVI_L_Idle0,RAP1074_S_RTAVI_L_Idle1,RAS1073_S_RTAVI_L_Idle1,I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI,I1071_S_TAVI_L_q0,I1070_S_TAVI_L_q0,I1069_S_TAVI_L_q0,I1068_S_TAVI_L_q0_L_AVI0,RAP1067_S_RTAVI_L_q1_L_Idle0,RAS1066_S_RTAVI_L_q1_L_Idle0,RAP1065_S_RTAVI_L_q1_L_Idle1,RAS1064_S_RTAVI_L_q1_L_Idle1,I1062_S_IncrClk_L_q1,I1061_S_IncrClk_L_q1,RVS1060_S_RURI_L_WaitURI_RURI,RVS1059_S_RURI_L_AVI0_RURI,RVS1057_S_RURI_L_AVI1_RURI,I1056_S_IncrClk_L_WaitURI_L_q1,I1055_S_IncrClk_L_AVI0_L_q1,I1054_S_IncrClk_L_Idle0_L_q1,I988_L_URI,
	{
		ParamDistr[0]= ( double ) 0 ;
	}

		break;
	}
}

REAL_TYPE SPN::GetPriority(TR_PL_ID t)const{
using namespace hybridVar;

	switch (t){
		case 28:	//D974_L_On
		return (double)0.91 ;
		break;
		case 24:	//D969_L_On
		return (double)0.92 ;
		break;
		case 67:	//D931_q0
		return (double)0.94 ;
		break;
		case 66:	//D900_L_URI
		return (double)0.95 ;
		break;
		case 8:	//D888_LRI
		return (double)0.96 ;
		break;
		case 41:	//D941_L_PVARP
		case 43:	//D944_L_PVAB
		return (double)0.97 ;
		break;
		case 17:	//D923_L_VRP
		return (double)0.98 ;
		break;
		case 27:	//I982_init
		case 30:	//I1090_L_Off
		return (double)1.91 ;
		break;
		case 23:	//I984_init
		case 26:	//I1092_L_Off
		return (double)1.92 ;
		break;
		case 31:	//I1052_S_Aget_L_Receive
		case 32:	//I1051_S_Aget_L_Receive
		case 33:	//I1050_S_Aget_L_Idle_L_Receive
		case 34:	//I956_L_Receive
		case 36:	//I1088_L_NoData
		return (double)1.93 ;
		break;
		case 48:	//I1072_S_TAVI_L_q0_S_RURI_L_AVI1_RURI
		case 49:	//I1071_S_TAVI_L_q0
		case 50:	//I1070_S_TAVI_L_q0
		case 51:	//I1069_S_TAVI_L_q0
		case 52:	//I1068_S_TAVI_L_q0_L_AVI0
		return (double)1.94 ;
		break;
		case 57:	//I1062_S_IncrClk_L_q1
		case 58:	//I1061_S_IncrClk_L_q1
		case 62:	//I1056_S_IncrClk_L_WaitURI_L_q1
		case 63:	//I1055_S_IncrClk_L_AVI0_L_q1
		case 64:	//I1054_S_IncrClk_L_Idle0_L_q1
		case 65:	//I988_L_URI
		return (double)1.95 ;
		break;
		case 9:	//I992_L_LRI
		case 11:	//I1102_L_LRI
		case 13:	//I1100_L_ASensed
		case 15:	//I1098_RLRI
		case 16:	//I990_L_LRI
		return (double)1.96 ;
		break;
		case 38:	//I1086_L_Idle
		case 40:	//I1084_L_Idle
		case 42:	//I942_L_Asig
		return (double)1.97 ;
		break;
		case 19:	//I1096_L_Idle
		case 20:	//I927_L_Vsig
		case 22:	//I1094_L_Idle
		return (double)1.98 ;
		break;
		case 0:	//EMPTY_AP
		case 1:	//EMPTY_AS
		case 2:	//EMPTY_RLRI
		case 3:	//EMPTY_SREC
		case 4:	//EMPTY_VP
		case 5:	//EMPTY_VS
		case 6:	//EMPTY_Vget
		return (double)3 ;
		break;
		case 7:	//INCOMING_SREC
		return (double)5 ;
		break;
		default:	//RAS891_,RRLRI892_,RRLRI893_,RVP926_,RVget928_,RAP964_,RVP975_,RSREC959_,RVP938_,RVS939_,RAP1076_S_RTAVI_L_Idle0,RAS1075_S_RTAVI_L_Idle0,RAP1074_S_RTAVI_L_Idle1,RAS1073_S_RTAVI_L_Idle1,RAP1067_S_RTAVI_L_q1_L_Idle0,RAS1066_S_RTAVI_L_q1_L_Idle0,RAP1065_S_RTAVI_L_q1_L_Idle1,RAS1064_S_RTAVI_L_q1_L_Idle1,RVS1060_S_RURI_L_WaitURI_RURI,RVS1059_S_RURI_L_AVI0_RURI,RVS1057_S_RURI_L_AVI1_RURI,
		return (double)3.99 ;
		break;
	}
}

REAL_TYPE SPN::GetWeight(TR_PL_ID t)const{
using namespace hybridVar;

		return (double)1 ;
}

void SPN::reset() {
	lastTransitionTime = 0;
	Marking.resetToInitMarking();
}

